;-128/64 KERNEL BY RAIG RUCE, STARTED 04-AR-1992.

;* SYSTEM ZERO-PAGE MEMORY USAGE:
;*   $02-$7F = APPLICATION WORK AREA
;*   $80-$8F = SYSTEM WORK AREA
;*   $F8-$FF = SYSTEM PARAMETER AREA

;* INITIAL  0 ORGANIZATION
;*   $0000-$0EFF = SYSTEM STORAGE
;*   $0F00-$0FFF = KERNEL INTERFACE VARIABLES
;*   $1000-$12FF = SYSTEM STORAGE
;*   $1300-$1FFF = HELL PROGRAM (3.25)
;*   $2000-$27FF = CHARACTER SET (2)
;*   $2800-$6FFF =  KERNEL AND DEVICE DRIVERS (18)
;*   $7000-$BFFF = APPLICATION AREA & STACK (20)
;*   $C000-$FFFF =  AND /,  (16)  [128,64]
;*   $D800-$DBFF = : SOFT-80 CHARSET [64,BITMAP]
;*   $DC00-$DFFF = : COLOR SCREEN [64,BITMAP]
;*   $E000-$FFFF = : BITMAPPED SCREEN [64,BITMAP]

;* FAR MEMORY TYPES
;*   $00=NULL, $01=REU, $02=INTERNAL-512, $06=RL-REU, $07=RL-RAM

COMPUTER = 128

.SEQ ACEHEAD.S
.SEQ KERNHEAD.S
.ORG $2800

.IF COMPUTER-64
   .OBJ "@0:ACE128"
.ELSE
   .OBJ "@0:ACE64"
.IFE

JMP ENTRYOINT

;***JUMP TABLE

JMP ACEPEN
JMP ACELOSE
JMP ACEEAD
JMP ACERITE
JMP ACEPEN     ;FASTOPEN
JMP ACELOSE    ;FASTCLOSE
JMP ACEEAD     ;FASTREAD
JMP ACELOAD
JMP ACEEMOVE
JMP ACEENAME
JMP ACEEVNFO
JMP ACECBWAP

JMP ACEIRPEN
JMP ACEIRLOSE
JMP ACEIREAD
JMP ACESDIR
JMP ACEHIR
JMP ACEDOME
JMP ACEKDIR
JMP ACEMDIR

JMP ACEPOAD
JMP ACEPTORE
JMP ACEETCH
JMP ACETASH
JMP ACEAGELLOC
JMP ACEAGEREE

JMP ACEINMAX
JMP ACEINCLS
JMP ACEINSET
JMP ACEINSIZE
JMP ACEINPUT
JMP ACEINCOLOR
JMP ACEINPOS
JMP ACEINCURSOR
JMP ACEINSCROLL

JMP CONEAD
JMP CONRITE
JMP CONUTCHAR
JMP CONUTCHARIT
JMP ACETOPEY
JMP CONETKEY
JMP CONOLOR
JMP CONALETTE
JMP CONCREEN
JMP CONOS

JMP ACEXEC
JMP ACEXECUB
JMP ACEXIT
JMP ACEEMTAT

JMP ACETOA
JMP ACEETATE
JMP ACEETATE
JMP ACEMDPEN
JMP ACEMDLOSE
JMP ACEMDEND
JMP ACEMDTATUS
JMP ACERCREEN
JMP ACERXIT
JMP ACERILL
JMP ACEROAD
JMP CONEYVAIL

.BYTE $FF,$FE,$3C,$E2,$FC

;***GLOBAL DECLARATIONS

MAXPSE    = $90
CONFIGUF   = $800
KEYLINEUF  = $900
FCBABLE1   = $B00

.IF COMPUTER-64
   MAXAGE = $C0
   BK = $0E
   BKAM0 = $3F
   BKERNEL = $00
   BKHARSET = $0F
   BKELECT = $FF00
   KERNELRQANDLER = $FA65
   KERNELRKANDLER = $B003
   KERNELMIANDLER = $FA40
.ELSE
   STRINGUFFER = $A00
   RAM0REEAP  = $1000
   FREEMAP      = $1100
   WORKBUF      = $1200
   MAXAGE = $D0
   BKELECT = $01
   BK = $36
   BKAM0 = $30
   BKERNEL = $37
   KERNELRQANDLER = $EA31
   KERNELRKANDLER = $FE66
   KERNELMIANDLER = $FE47
.IFE

CIA1  = $DC00
ST    = $90
TRUE  = $FF
FALSE = $00
CHR = $07
CHR = $09
CHR = $0A
CHR = $0D
CHR = $14
CHR = $93
CHR = $22

FCBOUNT = 16
LFTABLE   .BUF FCBOUNT
DEVTABLE  .BUF FCBOUNT
SATABLE   .BUF FCBOUNT
EOFTABLE  .BUF FCBOUNT
PIDTABLE  .BUF FCBOUNT
LFNULL = $FF
FCBULL = $FF
MINISK = 8
REGSAVE .BUF 3

NEWLF .BUF 1

KERNELLALL  = $FFE7
KERNELETBNK = $FF68
KERNELETMSG = $FF90
KERNELEADST = $FFB7
KERNELETLFS = $FFBA
KERNELETNAM = $FFBD
KERNELPEN   = $FFC0
.IF COMPUTER-64
KERNELLOSE  = $FFC3
.IFE
KERNELHKIN  = $FFC6
KERNELHKOUT = $FFC9
KERNELLRCHN = $FFCC
KERNELHRIN  = $FFCF
KERNELHROUT = $FFD2
KERNELOAD   = $FFD5
KERNELTOP   = $FFE1
KERNELETIN  = $FFE4
KERNELCRORG = $FFED
KERNELWAPPER = $FF5F

.IF COMPUTER-64
   ;128 NOTHING HERE
.ELSE
;*** KERNEL CLOSE WITH PSEUDO-CLOSE FOR DISK COMMAND CHANNEL FOR THE 64
KERNELLOSE = *
   BCS +
   JMP $FFC3
+  LDX $98
-  DEX
   BMI KERNELLOSEXIT
   CMP $259,X
   BNE -
   BEQ +
   BRK
   ;** FOUND ENTRY; COPY LAST ENTRY ON TOP IF IT
+  LDY $98
   DEY
   LDA $259,Y   ;MOVE LFN
   STA $259,X
   LDA $263,Y   ;MOVE DEV NUM
   STA $263,X
   LDA $26D,Y   ;MOVE SEC ADDR
   STA $26D,X
   DEC $98
   KERNELLOSEXIT = *
   CLC
   RTS
.IFE

;*** ENTRYPOINT()

ENTRYOINT = *
   LDA #0
   PHA
   PLP
   LDA #BK
   STA BKELECT
   JMP MAIN

;*** STARTUP()

ACEOOTSTRAP = *
   PHP
   SEI
   LDX #2
-  LDA $00,X
   STA BASICPAVE,X
   LDA #0
   STA $00,X
   INX
   CPX #MAXPSE
   BCC -
   LDA #<IRQANDLER
   LDY #>IRQANDLER
   STA $314
   STY $315
   LDA #<BRKANDLER
   LDY #>BRKANDLER
   STA $316
   STY $317
   LDA #<NMIANDLER
   LDY #>NMIANDLER
   STA $318
   STY $319
   LDX #127
   LDA #0
-  STA ERRNO,X
   DEX
   BPL -
   LDA #$04  ;"A:"
   STA ACEURRENTEVICE
   LDA #0
   JSR KERNELETMSG
.IF COMPUTER-64
   LDA #0
   LDX #0
   JSR KERNELETBNK
.IFE
   JSR KERNELLALL
   PLP
   RTS

ACEONFIG = *
   LDA #0
   LDX BOOTEVICE
   LDY #0
   JSR KERNELETLFS
   LDA #6
   LDX #<ACEONFIGAME
   LDY #>ACEONFIGAME
   JSR KERNELETNAM
   LDA #0
   LDX #<ACEPPDDRESS
   LDY #>ACEPPDDRESS
   JSR KERNELOAD
   BCC +
   RTS
+  LDA #<CONFIGUF
   LDY #>CONFIGUF
   STA 2
   STY 3
   LDA #<ACETARTUPSG
   LDY #>ACETARTUPSG
   STA 4
   STY 5
   LDA #<RAM0REEAP
   LDY #>RAM0REEAP
   STA 6
   STY 7
   LDX #>ACESSND
   LDA #<ACESSND
   BEQ +
   INX
+  STX 8
   .IF COMPUTER-64
   LDA #128
   .ELSE
   LDA #64
   .IFE
   STA 9
   LDA #<CHARSET4BIT
   LDY #>CHARSET4BIT
   STA 10
   STY 11
   JSR ACEPPDDRESS
   RTS
   ACEONFIGAME = *
   .ASC "CONFIG"

ACETARTUP = *
   LDX #FCBOUNT-1
   LDA #LFNULL
-  STA LFTABLE,X
   DEX
   BPL -
   LDA #0
   STA NEWLF
   LDA ACEURRENTEVICE
   LSR
   LSR
   ORA #$40
   STA ACEURIRAME+0
   LDA #":"
   STA ACEURIRAME+1
   LDA #0
   STA ACEURIRAME+2
   JSR INITTACK
   LDX #31
-  LDA CONFIGUF+$E0,X
   STA ACEHELLATH,X
   DEX
   BPL -
   LDA #0
   STA ACEHELLLIAS
   LDA #1
   STA ACEROCESS
   RTS

INITTACK = *
   LDA #ACE1
   STA ACE+0
   LDA #ACE2
   STA ACE+1
   LDA #0
   .IF COMPUTER-64
   LDY CONFIGUF+$A8
   .ELSE
   LDY CONFIGUF+$C6
   .IFE
   CPY #MAXAGE
   BCC +
   LDY #MAXAGE
+  STA ACETACKOP+0
   STY ACETACKOP+1
   STA ACEEMOP+0
   STY ACEEMOP+1
   STA ACERAMETR+0
   STY ACERAMETR+1
   RTS

;*** SHUTDOWN()

ACEHUTDOWN = *
   LDA #BK
   STA BKELECT
   LDX #2
-  LDA BASICPAVE,X
   STA $00,X
   INX
   CPX #MAXPSE
   BCC -
   PHP
   SEI
   LDA #<KERNELRQANDLER
   LDY #>KERNELRQANDLER
   STA $314
   STY $315
   LDA #<KERNELRKANDLER
   LDY #>KERNELRKANDLER
   STA $316
   STY $317
   LDA #<KERNELMIANDLER
   LDY #>KERNELMIANDLER
   STA $318
   STY $319
.IF COMPUTER-64
.ELSE
   LDA #%10000001
   STA $DC0D
   LDA #%01111111
   STA $DD0D
   BIT $DC0D
   BIT $DD0D
   LDA #%00000000
   STA VIC+$1A
.IFE
   PLP
   RTS

ACEHUTDOWNASIC = *
.IF COMPUTER-64
   JSR VDCHUTDOWN
   JSR VICHUTDOWN
   LDA TEXTODE
   EOR $D7
   BPL +
   JSR KERNELWAPPER
+  NOP
.ELSE
   LDA #25
   LDX #40
   ;XX CHECK CONFIG FOR SCREEN
   JSR CONSCREEN
.IFE
   JSR ACEHUTDOWN
   LDA #147
   JSR KERNELHROUT
   LDA #BKERNEL
   STA BKELECT
.IF COMPUTER-64
   LDA #0
   STA $F8
   STA $F9
   LDA #$16
   STA 2604
   STA $D018
   LDA #0
   STA $1C00
   STA 208
   JSR $51D6
   JMP $4DB7
.ELSE
   LDA #$16
   STA $D018
   LDA #0
   STA $800
   STA 198
   JSR $A642
   JMP $A474
.IFE
   BRK

RESETNTISPATCH = *  ;FOR 64 ONLY, 0
   LDX #$FF
   SEI
   TXS
   CLD
   LDA #BKERNEL
   STA BKELECT
   JMP $FCE2

NMINTISPATCH = *  ;FOR 64 ONLY, 0
   SEI

NMIANDLER = *
.IF COMPUTER-64
   CLD
   LDA #BK
   STA BKELECT
   LDA #$7F
   STA $DD0D
   LDY $DD0D
   BMI +
-  LDA $DC01
   CMP $DC01
   BNE -
   AND #$80
   BMI +
   JSR ACEHUTDOWN
   ;JSR SHUTDOWNEMORY
   ;LDA #147
   ;JSR KERNELHROUT
   ;JMP ACEHUTDOWNASIC
   JSR $E056
   JSR $E109
   JSR $C000
   LDA #0
   STA $1C00
   LDA #BKERNEL
   STA BKELECT
   JSR $51D6
   JMP ($0A00)
+  JMP $FF33
.ELSE
   CLD
   PHA
   TXA
   PHA
   TYA
   PHA
   LDA BKELECT
   PHA
   LDA #BKERNEL
   STA BKELECT
   LDA #$7F
   STA $DD0D
   LDY $DD0D
   BMI +
-  LDA $DC01
   CMP $DC01
   BNE -
   AND #$80
   BMI +
   JSR ACEHUTDOWN
   JSR $FD15
   JSR $FDA3
   JSR $E518
   LDA #0
   STA $800
   JSR $A642
   JMP ($A002)
+  PLA
   STA BKELECT
   PLA
   TAY
   PLA
   TAX
   PLA
   RTI
.IFE

ACERQNIT = *
   PHP
   SEI
.IF COMPUTER-64
.ELSE
   LDX #5
-  LDA C64NTECS,X
   STA $FFFA,X
   DEX
   BPL -
.IFE
   LDA #<IRQANDLER
   LDY #>IRQANDLER
   STA $314
   STY $315
   LDA #%01111111
   STA $DC0D
   STA $DD0D
   BIT $DC0D
   BIT $DD0D
   LDA VIC+$11
   AND #%01111111
   ORA #%00000000
   STA VIC+$11
   LDA #252
   STA VIC+$12
   LDA #%00000000
   STA VIC+$1A
   LDA #%10001111
   STA VIC+$19
   PLP
   RTS

C64NTECS = *
   .WORD NMINTISPATCH,RESETNTISPATCH,IRQNTISPATCH

IRQNTISPATCH = *  ;FOR 64 ONLY, 0
   PHA
   TXA
   PHA
   TYA
   PHA
   LDA BKELECT
   PHA
   LDA #BKERNEL
   STA BKELECT
   CLD
   TSX
   LDA $0105,X
   AND #$10
   BEQ IRQANDLERNT64
   JMP BRKANDLER

IRQANDLER = *  ;(. ALREADY SAVED, 128 BANK)
   CLD
.IF COMPUTER-64
.ELSE
   LDA BKELECT
   PHA
.IFE
   IRQANDLERNT64 = *
   LDA #BK
   STA BKELECT
   LDA VIC+$19
   BPL +
   AND #1
   BNE SIXTY
+  LDA $DC0D
   JMP IRQXIT

SIXTY = *
   STA VIC+$19
   JSR CONCREENAVE
   JSR VICRQURSOR
   JSR VDCRQURSOR
   JSR CONRQEYSCAN
   JMP IRQXIT

.IF COMPUTER-64
IRQXIT = $FF33
.ELSE
IRQXIT = *
   PLA
   STA BKELECT
   PLA
   TAY
   PLA
   TAX
   PLA
   RTI
.IFE

BRKANDLER = *
   CLD
   LDX #0
-  LDA $00,X
   STA $0400,X
   DEX
   BNE -
   JSR ACEHUTDOWN
.IF COMPUTER-64
   LDA #0
   STA $1C00
   ;JSR $51D6
.ELSE
   LDA #0
   STA $800
   JSR $A642
.IFE
   JMP KERNELRKANDLER

;*** GETEVICE( ZP=FILENAME ) : .=DEVICE, .=SCANOS

GETEVICE = *
   LDY #0
   LDA (ZP),Y
   BEQ USEEFAULT
   LDY #1
   LDA (ZP),Y
   CMP #":"
   BNE USEEFAULT
   LDY #0
   LDA (ZP),Y
   LDY #2
   CMP #"."
   BNE +
   LDA ACEURRENTEVICE
   JMP GOTEV
+  AND #$1F
   ASL
   ASL
   JMP GOTEV
   
   USEEFAULT = *
   LDA ACEURRENTEVICE
   LDY #0

   GOTEV = *
   RTS
   
GETFNDCB = * ;() : .=FCB, .=LF
   OPENFEARCH = *
   INC NEWLF
   LDA NEWLF
   AND #$7F
   LDX #FCBOUNT-1
-  CMP LFTABLE,X
   BEQ OPENFEARCH
   DEX
   BPL -
   TAY
   LDX #0
-  LDA LFTABLE,X
   BMI +
   INX
   CPX #FCBOUNT
   BCC -
   LDA #ACERROOANYILES
   STA ERRNO
   SEC
   RTS
+  LDA ACEROCESS
   STA PIDTABLE,X
   TYA
   CLC
   RTS

;*** ISDIR( (ZP)=ILENAME ) : .=EV, .=ISISK, .=ISIR

ACESDIR = *
   JSR GETEVICE
   PHA
   TAX
   LDA CONFIGUF+0,X
   CMP #1
   BEQ +
   CMP #4
   BEQ +
   LDX #FALSE
   LDY #FALSE
   JMP ISIRXIT
   LDX #TRUE
+  LDY #255
-  INY
   LDA (ZP),Y
   BNE -
   DEY
   LDA (ZP),Y
   LDY #TRUE
   CMP #":"
   BEQ ISIRXIT
   LDY #FALSE

   ISIRXIT = *
   PLA
   RTS

;*** OPEN( ZP=FILENAME, .=MODE["R","W","A"] ) : .=FCB

OPENCB      = SYSWORK+0
OPENAMECAN = SYSWORK+1
OPENODE     = SYSWORK+2
OPENAMEENGTH = SYSWORK+3
OPENEVICE   = SYSWORK+4
CHECKTAT .BUF 1

ACEPEN = *
   STA OPENODE
   LDA #TRUE
   STA CHECKTAT
   JSR GETFNDCB
   BCC +
   RTS
+  STA LFTABLE,X
   LDA #$00
   STA EOFTABLE,X
   STX OPENCB
   JSR GETEVICE
   STY OPENAMECAN
   LDX OPENCB
   STA DEVTABLE,X
   STA OPENEVICE
   TAX

   ;GET SA HERE
   LDA CONFIGUF+0,X
   CMP #0
   BNE +
   LDY CONFIGUF+2,X
   JMP NONISKA
+  LDY #0
   CMP #1
   BEQ OPENISKA
   ;** CHECK CONSOLE
   CMP #2
   BNE +
-  LDA OPENCB
   CLC
   RTS
   ;** CHECK NULL DEVICE
+  CMP #3
   BEQ -
   ;** CHECK RAMDISK DEVICE
   CMP #4
   BNE +
   JMP RDPEN
   ;** CHECK PARALLEL PORT DEVICE
+  CMP #5
   BNE +
   JMP PARPEN
   ;** ILLEGAL DEVICE
+  LDA #ACERRLLEGALEVICE
   STA ERRNO
   SEC
   RTS

   OPENISKA = *
   LDY #2
   DISKAEARCH = *
   LDX #FCBOUNT-1
-  LDA LFTABLE,X
   BMI +
   LDA DEVTABLE,X
   CMP OPENEVICE
   BNE +
   TYA
   CMP SATABLE,X
   BNE +
   INY
   BNE DISKAEARCH
+  DEX
   BPL -

   NONISKA = *
   LDX OPENCB
   TYA
   STA SATABLE,X

   ;SET THE NAME
   LDX #0
   LDY OPENAMECAN
-  LDA (ZP),Y
   STA STRINGUFFER,X
   BEQ +
   INY
   INX
   BNE -
+  LDY OPENEVICE
   LDA CONFIGUF+0,Y
   CMP #1
   BNE NONISKPEN
   ;** STICK THE MODE FOR DISK FILES
   CPX #0
   BNE +
   LDA #ACERRPENIRECTORY
   SEC
   RTS
+  LDA #","
   STA STRINGUFFER,X
   INX
   LDA OPENODE
   STA STRINGUFFER,X
   INX
   JMP OPENOTAME

   ;** GET RID OF THE FILENAME FOR NON-DISKS
   NONISKPEN = *
   LDX #0

   OPENOTAME = *
   ;** DISPATCH HERE FOR NON-KERNEL DEVICES
   TXA
   LDX #<STRINGUFFER
   LDY #>STRINGUFFER
   JSR KERNELETNAM

   ;SET LFS
   LDX OPENCB
   LDA LFTABLE,X
   PHA
   LDA SATABLE,X
   TAY
   LDA DEVTABLE,X
   TAX
   LDA CONFIGUF+1,X
   TAX
   PLA
   JSR KERNELETLFS

   ;DO THE OPEN
   JSR KERNELPEN
   BCS OPENRROR
+  LDX OPENEVICE
   LDA CONFIGUF+0,X
   CMP #1
   BNE +
   LDA CHECKTAT
   BEQ +
   TXA
   JSR OPENISKTATUS
   BCC +

   OPENRROR = *
   STA ERRNO
   LDX OPENCB
   LDA LFTABLE,X
   CLC
   JSR KERNELLOSE
   LDX OPENCB
   LDA #LFNULL
   STA LFTABLE,X
   SEC
   LDA #FCBULL
   RTS
+  LDA OPENCB
   CLC
   RTS

OPENISKTATUS = *  ;( .=DEVICE ) : ERRNO=.=ERRCODE, .=ERRFLAG
   JSR CMDCHPEN
   BCS +
   JSR CHECKISKTATUS
   PHP
   PHA
   JSR CMDCHLOSE
   PLA
   PLP
+  RTS

CMDCHPEN = *  ;( .=DEVICE )
   PHA
   JSR CMDCHLOSE
   PLA
   TAX
   LDA CONFIGUF+1,X
   TAX
   LDY #15
   LDA #LFNULL
   JSR KERNELETLFS
   LDA #0
   JSR KERNELETNAM
   JSR KERNELPEN
   BCC +
   STA ERRNO
+  RTS

CMDCHEND = *  ;( STRINGUFFER )
   LDX #LFNULL
   JSR KERNELHKOUT
   BCS CMDCHRR
   LDX #0
-  LDA STRINGUFFER,X
   BEQ +
   JSR KERNELHROUT
   BCS CMDCHRR
   INX
   BNE -
+  JSR KERNELLRCHN
   CLC
   RTS

   CMDCHRR = *
   STA ERRNO
   PHA
   JSR KERNELLRCHN
   PLA
   SEC
   RTS

CHECKISKTATUSODE .BUF 1

CHECKISKTATUS = *
   LDX #LFNULL
   JSR KERNELHKIN
   BCS CMDCHRR
   JSR KERNELHRIN
   BCS CMDCHRR
   AND #$0F
   STA CHECKISKTATUSODE
   ASL
   ASL
   ADC CHECKISKTATUSODE
   ASL
   STA CHECKISKTATUSODE
   JSR KERNELHRIN
   BCS CMDCHRR
   AND #$0F
   CLC
   ADC CHECKISKTATUSODE
   STA CHECKISKTATUSODE
-  JSR KERNELEADST
   AND #$80
   BEQ +
   LDA #ACERREVICEOTRESENT
   SEC
   BCS CMDCHRR
+  JSR KERNELHRIN
   BCS CMDCHRR
   CMP #CHR
   BNE -
   JSR KERNELLRCHN
   LDA CHECKISKTATUSODE
   CMP #62
   BNE +
   LDA #ACERRILEOTOUND
   STA ERRNO
   SEC
   RTS
+  CMP #20
   BCC +
   STA ERRNO
+  RTS

CMDCHLOSE = *
   SEC
   LDA #LFNULL
   JSR KERNELLOSE
   BCC +
   STA ERRNO
+  RTS

;*** CLOSE( .=FCB )

CLOSED .BUF 1

ACELOSE = *
   TAX
   LDA PIDTABLE,X
   CMP ACEROCESS
   BEQ +
   CLC
   RTS
+  LDY DEVTABLE,X
   STX CLOSED
   LDA CONFIGUF+0,Y
   CMP #2
   BNE +
   JMP CLOSEDNTRY
+  CMP #3
   BNE +
   JMP CLOSEDNTRY
+  CMP #4
   BNE +
   JSR RDLOSE
   JMP CLOSEDNTRY
+  CMP #5
   BNE +
   JMP PARLOSE
+  LDX CLOSED
   LDA LFTABLE,X
   JSR KERNELLOSE

   CLOSEDNTRY = *
   LDX CLOSED
   LDA #LFNULL
   STA LFTABLE,X
   CLC
   RTS

;*** READ( .=FCB, (ZP)=DATA, .=MAXENGTH ) : .=(ZW)=LENGTH, .=EOF

READAXEN     = SYSWORK+0
READTR        = SYSWORK+2
READENGTH     = SYSWORK+4
READCB        = SYSWORK+6
READEVICEISK = SYSWORK+7

ACEEAD = *
   STA READAXEN+0
   STY READAXEN+1
   STX READCB
   LDA ZP+0
   LDY ZP+1
   STA READTR+0
   STY READTR+1
   LDA #0
   STA READENGTH+0
   STA READENGTH+1
   LDA EOFTABLE,X
   BEQ +
   JMP READOFXIT
+  LDY #0
   LDA DEVTABLE,X
   TAX
   LDA CONFIGUF+0,X
   CMP #4
   BNE +
   JMP RDEAD
+  CMP #5
   BNE +
   JMP PAREAD
+  CMP #2
   BNE +
   LDA READAXEN+0
   LDY READAXEN+1
   LDX READCB
   JMP CONEAD
+  CMP #3
   BNE +
   LDA #0
   LDY #0
   STA ZW+0
   STY ZW+1
   CLC
   RTS
+  CMP #1
   BNE +
   LDY #$FF
+  LDX READCB
   STY READEVICEISK
   LDA LFTABLE,X
   TAX
   JSR KERNELHKIN
   BCC READYTE
   STA ERRNO
   RTS
   
   READYTE = *
   LDA READENGTH+0
   CMP READAXEN+0
   LDA READENGTH+1
   SBC READAXEN+1
   BCS READXIT
   JSR KERNELHRIN
   LDY #0
   STA (READTR),Y
   INC READTR+0
   BNE +
   INC READTR+1
+  INC READENGTH+0
   BNE +
   INC READENGTH+1
+  BIT READEVICEISK
   BPL READYTE
   LDA ST
   AND #$40
   BEQ READYTE
   LDX READCB
   STA EOFTABLE,X

   READXIT = *
   JSR KERNELLRCHN
   READXITOCLR = *
   LDA READENGTH+0
   LDY READENGTH+1
   STA ZW+0
   STY ZW+1
   LDX #$FF
   CLC
   RTS

   READOFXIT = *
   LDA #0
   LDY #0
+  STA ZW+0
   STY ZW+1
   CLC
   RTS

;*** WRITE( .=FCB, (ZP)=DATA, .=LENGTH )

WRITEENGTH = SYSWORK+0
WRITETR    = SYSWORK+2

ACERITE = *
   STA WRITEENGTH+0
   STY WRITEENGTH+1
   LDA ZP+0
   LDY ZP+1
   STA WRITETR+0
   STY WRITETR+1
   STX REGSAVE+1
   LDA DEVTABLE,X
   TAX
   LDA CONFIGUF+0,X
   ;** CHECK RAMDISK
   CMP #4
   BNE +
   JMP RDRITE
   ;** CHECK PARALLEL PORT
+  CMP #5
   BNE +
   JMP PARRITE
   ;** CHECK CONSOLE
+  CMP #2
   BNE +
   LDA WRITEENGTH+0
   LDY WRITEENGTH+1
   LDX REGSAVE+1
   JMP CONRITE
   ;** CHECK NULL DEVICE
+  CMP #3
   BNE +
   CLC
   RTS
+  LDX REGSAVE+1
   LDA LFTABLE,X
   TAX
   JSR KERNELHKOUT
   BCC WRITEYTE
   RTS

   WRITEYTE = *
   LDA WRITEENGTH+0
   ORA WRITEENGTH+1
   BEQ WRITEINISH
   LDY #0
   LDA (WRITETR),Y
   JSR KERNELHROUT
   BCC +
   STA ERRNO
   JSR KERNELLRCHN
   SEC
   RTS
+  INC WRITETR+0
   BNE +
   INC WRITETR+1
+  LDA WRITEENGTH+0
   BNE +
   DEC WRITEENGTH+1
+  DEC WRITEENGTH+0
   JMP WRITEYTE
   
   WRITEINISH = *
   JSR KERNELLRCHN
   CLC
   RTS

;*** CMDOPEN( (ZP)=EVAME ) : .=CB

GETISKEVICE = *  ;( (ZP)=DEVNAME ) : .=DEVICE, .=SCAN, .=DEV_T, .=ISISK
   JSR GETEVICE
   PHA
   TAX
   LDA CONFIGUF+0,X
   CMP #1
   BNE +
-  TAX
   PLA
   CLC
   RTS
+  CMP #4
   BEQ -
   PLA
   LDA #ACERRISKNLYPERATION
   STA ERRNO
   SEC
   RTS
   
ACEMDPEN = *
   JSR GETISKEVICE
   BCC +
   RTS
+  STA OPENEVICE
   JSR GETFNDCB
   BCC +
   RTS
+  STA LFTABLE,X
   STX OPENCB
   LDA OPENEVICE
   STA DEVTABLE,X
   LDA #0
   STA EOFTABLE,X
   LDA #15
   STA SATABLE,X
   STX OPENCB
   LDA #0
   STA STRINGUFFER
   LDA #FALSE
   STA CHECKTAT
   LDX #0
   JSR OPENOTAME
   BCC +
   RTS
+  LDA ST
   AND #$80
   BEQ +
   LDA #ACERREVICEOTRESENT
   STA ERRNO
   SEC
   RTS
+  LDA OPENCB
   RTS

;*** CMDCLOSE( .=FCB )

ACEMDLOSE = *
   TAX
   LDA LFTABLE,X
   PHA
   LDA #LFNULL
   STA LFTABLE,X
   PLA
   SEC
   JMP KERNELLOSE

;*** CMDSEND( .=CB, .=MD )

ACEMDEND = *
   STA SYSWORK+0
   STY SYSWORK+1
   LDA LFTABLE,X
   TAX
   JSR KERNELHKOUT
   BCC +
   STA ERRNO
   RTS
+  LDY #0
-  LDA (SYSWORK),Y
   BEQ +
   JSR KERNELHROUT
   BCS ++
   INY
   BNE -
+  JSR KERNELLRCHN
   CLC
   RTS
+  STA ERRNO
   JSR KERNELLRCHN
   SEC
   RTS

;*** CMDSTATUS( .=CB, .=TATUSUF ) : TATUSUF, .=STATUSODE

ACEMDTATUS = *
   STA SYSWORK+0
   STY SYSWORK+1
   LDA LFTABLE,X
   TAX
   JSR KERNELHKIN
   BCC +
-  STA ERRNO
   JSR KERNELLRCHN
   SEC
   RTS
+  LDY #0
-  JSR KERNELHRIN
   BCS --
   CMP #$0D
   BEQ +
   STA (SYSWORK),Y
   INY
   JSR KERNELEADST
   AND #$40
   BEQ -
+  LDA #0
   STA (SYSWORK),Y
   JSR KERNELLRCHN
   LDY #0
   LDA (SYSWORK),Y
   AND #$0F
   ASL
   ASL
   ADC (SYSWORK),Y
   ASL
   STA SYSWORK+3
   INY
   LDA (SYSWORK),Y
   AND #$0F
   ADC SYSWORK+3
   CLC
   RTS

DEVABLENIT = *
   LDX #0
   LDA #ACEEMULL
-  STA DEVICEABLE,X
   INX
   BNE -
   RTS

.SEQ ACECALL.S
.SEQ ACEMEM.S
.SEQ ACECON.S
.SEQ ACERD.S
.SEQ ACEPAR.S

;*** SCREEN CALLS

TEXTODE .BUF 1

.IF COMPUTER-64
   .SEQ ACEVDC.S
   .SEQ ACEVIC.S
.ELSE
   .SEQ ACEVIC80.S
   .SEQ ACEVIC.S
.IFE

SCREENNIT = *
   LDA #0
   STA TEXTODE
.IF COMPUTER-64
   JSR VDCNIT
   JSR VICNIT
   LDX #80
   BIT $D7
   BMI +
   LDX #40
+  LDA #0
   JSR CONSCREEN
.ELSE
   JSR VDCTARTUP
   JSR VICNIT
   LDX #40
   BIT CONFIGUF+$C0
   BVC +
   LDX #80
+  LDA #0
   JSR CONSCREEN
.IFE
   RTS

ACEINMAX = *
   BIT TEXTODE
   BMI +
   JMP VICINMAX
+  JMP VDCINMAX
ACEINCLS = *
   BIT TEXTODE
   BMI +
   JMP VICINCLS
+  JMP VDCINCLS
ACEINSET = *
   BIT TEXTODE
   BMI +
   JMP VICINSET
+  JMP VDCINSET
ACEINSIZE = *
   BIT TEXTODE
   BMI +
   JMP VICINSIZE
+  JMP VDCINSIZE
ACEINPUT = *
   BIT TEXTODE
   BMI +
   JMP VICINPUT
+  JMP VDCINPUT
ACEINCOLOR = *
   BIT TEXTODE
   BMI +
   JMP VICINCOLOR
+  JMP VDCINCOLOR
ACEINPOS = *
   BIT TEXTODE
   BMI +
   JMP VICINPOS
+  JMP VDCINPOS
ACEINCURSOR = *
   BIT TEXTODE
   BMI +
   JMP VICINCURSOR
+  JMP VDCINCURSOR
ACEINSCROLL = *
   BIT TEXTODE
   BMI +
   JMP VICINSCROLL
+  JMP VDCINSCROLL

;*** MAIN()

BOOTEVICE .BUF 1
TITLETR   .BUF 2
TITLEEN   .BUF 2
EXITLS    .BYTE 0

MAIN = *
   LDA 186
   STA BOOTEVICE
   LDA #147
   JSR KERNELHROUT
   LDA #14
   JSR KERNELHROUT
   LDX #0
-  LDA ACETARTUPSG,X
   BEQ +
   JSR KERNELHROUT
   INX
   BNE -
+  SEI
   JSR ACEOOTSTRAP
   JSR ACERQNIT
   JSR INITEMORY
   JSR ACEONFIG
   BCC +
   JMP MAINXIT
+  LDA 2
   LDY 3
   STA TITLETR+0
   STY TITLETR+1
   LDA 4
   LDY 5
   STA TITLEEN+0
   STY TITLEEN+1
   JSR ACETARTUP
   JSR INITEMORYLLOC
   SEI
   JSR SCREENNIT
   JSR CONNIT
   JSR DEVABLENIT
   JSR RDNIT
   JSR PARNIT
   LDA #%00000001
   STA VIC+$1A
   CLI
   LDA #$FF
   STA EXITLS

   ;** OPEN STD FILES
   LDA #<CONFIGUF+$90
   LDY #>CONFIGUF+$91
   STA ZP+0
   STY ZP+1
   JSR CHDIR
   LDA #<STDINAME
   LDY #>STDINAME
   STA ZP+0
   STY ZP+1
   LDA #"R"
   JSR OPEN  ;FCB=0
   LDA #<STDOUTAME
   LDY #>STDOUTAME
   STA ZP
   STY ZP+1
   LDA #"W"
   JSR OPEN   ;FCB=1
   LDA #"W"
   JSR OPEN   ;FCB=2
   LDA TITLETR+0
   LDY TITLETR+1
   STA ZP+0
   STY ZP+1
   LDA TITLEEN+0
   LDY TITLEEN+1
   LDX #STDOUT
   JSR WRITE
   CLI

   ;** CALL SHELL
   LDA ACEEMOP+0
   LDY ACEEMOP+1
   SEC
   SBC #7
   BCS +
   DEY
+  STA ZW+0
   STY ZW+1
   LDY #6
-  LDA STARTUPRGS,Y 
   STA (ZW),Y
   DEY
   BPL -
   LDY #0
   CLC
   LDA ZW+0
   ADC #4
   STA (ZW),Y
   INY
   LDA ZW+1
   ADC #0
   STA (ZW),Y
   LDA #<ACEHELLDDRESS
   LDY #>ACEHELLDDRESS
   STA ZP+0
   STY ZP+1
   LDA #1
   LDY #0
   JSR EXECSUB

   ;** EXIT
   MAINXIT = *
   LDA #STDIN
   JSR CLOSE
   LDA #STDOUT
   JSR CLOSE
   LDA #STDERR
   JSR CLOSE
   LDA BOOTEVICE
   STA 186
   JSR SHUTDOWNEMORY
   BIT EXITLS
   BPL +
   LDA #147
   JSR KERNELHROUT
+  JMP ACEHUTDOWNASIC

STDOUTAME .ASC "S:"
           .BYTE 0
STDINAME  .ASC "K:"
           .BYTE 0

STARTUPRGS .BYTE 0,0,0,0,"S","H",0
   
ACETARTUPSG = *
.IF COMPUTER-64
   .ASC "-128 "
.ELSE
   .ASC "-64  "
.IFE
   .ASC "ERNEL 0.77.00 -  22-CT-94"
   .BYTE CHR,CHR,0

;*** BSS: C128=1536 BYTES, C64=512 BYTES

ACESS = *
.IF COMPUTER-64
   CHARSET4BIT  = ACESS+0  ;(0 BYTES)
   STRINGUFFER = ACESS+0
   RAM0REEAP  = STRINGUFFER+256
   FREEMAP      = RAM0REEAP+256
   DEVICEABLE  = FREEMAP+256
   BASICPAVE  = DEVICEABLE+256
   WORKBUF      = BASICPAVE+256
   ACESSND    = WORKBUF+256
.ELSE
   DEVICEABLE  = ACESS+0
   BASICPAVE  = DEVICEABLE+256
   ACESSND    = BASICPAVE+256
.IFE
