;-128/64 KERNEL CONSOLE DRIVER: HIGH LEVEL / & KEYBOARD

CONINTART  .BUF 2
CONINOWS   .BUF 1
CONINOLS   .BUF 1
CONOWNC    .BUF 2
CONINEDDR  .BUF 2
CONUROW    .BUF 1
CONUROL    .BUF 1

CONUTASK   .BYTE $80  ;.BUF 1
CONHAROLOR .BYTE $0E  ;.BUF 1
CONURSOROLOR .BYTE $07 ;.BUF 1
CONGNORETRL .BYTE $00

KEYLINEEXT  = KEYLINEUF+0  ;(3)
KEYLINEREV  = KEYLINEUF+3  ;(3)
KEYLINEEN   = KEYLINEUF+6  ;(1)
KEYLINELAGS = KEYLINEUF+7  ;(1)
KEYLINE      = KEYLINEUF+8  ;(248)
KEYLINEAX   = 248

KEYLINETR   .BUF 1
KEYLINEOS   .BUF 1
KEYLINEOUNT .BUF 1

.IF COMPUTER-64
   SHIFTALUE = $D3
.ELSE
   SHIFTALUE = $28D
.IFE

CONNITINEUM .BUF 1
CONISTBUFCANTR .BUF 4
CONISTBUFEPLACETR .BUF 4
CONNITREV = SYSWORK+4

CONNIT = *
   LDA CONFIGUF+$8E
   STA CONSAX
   STA CONSOUNTDOWN
   LDA #0
   STA KEYLINEOUNT
   JSR KEYSCANNIT
   LDA #ACEEMULL
   STA CONISTBUFCANTR+3
   STA CONISTBUFEPLACETR+3
   STA CONNITREV+3
   LDA #$00
   STA CONNITREV+0
   LDA CONFIGUF+$CB
   BNE +
   JMP CONINNIT
+  STA CONNITINEUM

   CONNITEXT = *
   LDA CONNITINEUM
   BNE +
   JMP CONNITLEANIST
+  LDA #1
   LDX #$00  ;XXX GO FOR THE SLOW
   LDY #$FF
   JSR PAGEALLOC
   BCS CONNITLEANIST
   ;** CHECK FIRST LINE
   LDA CONISTBUFEPLACETR+3
   CMP #ACEEMULL
   BNE +
   LDX #3
-  LDA MP,X
   STA CONISTBUFEPLACETR,X
   DEX
   BPL -
   ;** INITIALIZE LINE
+  LDX #2
-  LDA CONISTBUFEPLACETR+1,X
   STA KEYLINEEXT,X
   LDA CONNITREV+1,X
   STA KEYLINEREV,X
   LDA MP+1,X
   STA CONNITREV+1,X
   DEX
   BPL -
   LDA #0
   STA KEYLINEEN
   STA KEYLINELAGS
   ;** STORE NEW LINE
   LDA #<KEYLINEUF
   LDY #>KEYLINEUF
   STA ZP+0
   STY ZP+1
   LDA #9
   LDY #0
   JSR STASH
   ;** LINK PREVIOUS LINE'S NEXT POINTER
   LDX #2
-  LDA KEYLINEREV,X
   STA MP+1,X
   DEX
   BPL -
   LDA #$00
   STA MP+0
   LDX #CONNITREV+1
   LDY #3
   JSR ZPSTORE
   ;** GO ON TO NEXT LINE
   DEC CONNITINEUM
   JMP CONNITEXT

   CONNITLEANIST = *
   LDA CONISTBUFEPLACETR+3
   CMP #ACEEMULL
   BEQ CONINNIT
   ;** LINK FIRST LINE'S PREV PTR TO LAST LINE
   LDX #3
-  LDA CONISTBUFEPLACETR,X
   STA MP,X
   DEX
   BPL -
   LDA #$03
   STA MP+0
   LDX #CONNITREV+1
   LDY #3
   JSR ZPSTORE
   ;XX FALL THROUGH

CONINNIT = *
   JSR CONINARMS
   JMP CONLS

CONINARMS = *
   JSR WINSIZE
   STA CONINOWS
   STX CONINOLS
   LDA SYSWORK+2
   LDY SYSWORK+3
   STA CONINTART+0
   STY CONINTART+1
   LDA SYSWORK+4
   LDY SYSWORK+5
   STA CONOWNC+0
   STY CONOWNC+1
   RTS

CONLS = *
   LDA #$E0
   LDX #" "
   LDY CONHAROLOR
   JSR WINCLS
   JSR CONOME
   RTS

CONHUTDOWN = *
   RTS

CONINHANGEALLBACK = *
   JSR CONINARMS
   JMP CONOME
   RTS

CONOME = *
   LDA CONINTART+0
   LDY CONINTART+1
   STA CONINEDDR+0
   STY CONINEDDR+1
   LDA #0
   STA CONUROW
   STA CONUROL
   RTS

CONUTAVE .BUF 1

CONUTCHAR = *  ;( .=CHAR )
   CMP #CHR
   BEQ CONEWLINE
   CMP #CHR
   BEQ CONLS
   CMP #CHR
   BNE +
   JMP CONAB
+  CMP #CHR
   BNE +
   JMP CONACKSPACE
+  CMP #CHR
   BNE +
   JMP CONELL
+  CMP #CHR
   BNE CONUTCHARIT
   JMP CONINEFEED

   CONUTCHARIT = *  ;( .=CHAR )
   STA CONUTAVE
   LDA CONUROL
   CMP CONINOLS
   BCC +
   JSR CONEWLINE
+  CLC
   LDA CONINEDDR+0
   ADC CONUROL
   STA SYSWORK+0
   LDA CONINEDDR+1
   ADC #0
   STA SYSWORK+1
   LDA #<CONUTAVE
   LDY #>CONUTAVE
   STA SYSWORK+2
   STY SYSWORK+3
   LDX #1
   STX SYSWORK+5
   LDA CONUTASK
   LDY CONHAROLOR
   JSR WINPUT
   INC CONUROL
   RTS

CONETURSORDDR = *
   CLC
   LDA CONINEDDR+0
   ADC CONUROL
   STA SYSWORK+0
   LDA CONINEDDR+1
   ADC #0
   STA SYSWORK+1
   RTS

CONYNCHURSOR = *
   LDA CONUROL
   CMP CONINOLS
   BCC +
   JSR CONEWLINE
+  RTS

CONEWLINE = *
   LDA CONGNORETRL
   BMI +
-  LDA SHIFTALUE
   AND #$0F
   CMP #$04
   BEQ -
   LDA SCROLLREEZE
   BNE -
+  LDA #0
   STA CONUROL
   INC CONUROW
   LDA CONUROW
   CMP CONINOWS
   BCS +
   CLC
   LDA CONINEDDR+0
   ADC CONOWNC+0
   STA CONINEDDR+0
   LDA CONINEDDR+1
   ADC CONOWNC+1
   STA CONINEDDR+1
   CLC
   RTS
+  DEC CONUROW
   JSR CONCROLL
   CLC
   RTS

CONCROLL = *
   LDA #20
   STA SCROLLOUNTDOWN
-  LDA SHIFTALUE
   AND #%10
   BEQ +
   CLI
   LDA SCROLLOUNTDOWN
   BNE -
+  LDA #" "
   STA SYSWORK+4
   LDA CONUTASK
   ORA #$08
   LDX #1
   LDY CONHAROLOR
   JSR WINSCROLL
   RTS

CONAB = *
   LDA CONUROL
   AND #7
   STA SYSWORK+0
   SEC
   LDA #8
   SBC SYSWORK+0
   CLC
   ADC CONUROL
   CMP CONINOLS
   BCC +
   LDA CONINOLS
+  STA CONUROL
   RTS

CONINEFEED = *
   LDA #0
   STA CONUROL
   RTS

CONELL = *
   LDA #$15
   STA $D418
   LDY #$09
   LDX #$00
   STY $D405
   STX $D406
   LDA #$30
   STA $D401
   LDA #$20
   STA $D404
   LDA #$21
   STA $D404
   RTS

;*** CONRITE( (ZP)=BUF, .=WRITEENGTH ) **ZW GETS MODIFIED**

CONRITETR    = SYSWORK+8
CONRITEENGTH = SYSWORK+10
CONRITEEMP   = SYSWORK+12

CONRITE = *
   STA CONRITEENGTH+0
   STY CONRITEENGTH+1
   LDA ZP+0
   LDY ZP+1
   STA CONRITETR+0
   STY CONRITETR+1

   CONRITEEXTHUNK = *
   LDA #255
   LDX CONRITEENGTH+1
   BNE +
   LDA CONRITEENGTH+0
   BEQ CONRITEINISH
+  JSR CONRITEHUNK
   STA CONRITEEMP
   CLC
   ADC CONRITETR+0
   STA CONRITETR+0
   BCC +
   INC CONRITETR+1
+  SEC
   LDA CONRITEENGTH+0
   SBC CONRITEEMP
   STA CONRITEENGTH+0
   BCS +
   DEC CONRITEENGTH+1
+  JMP CONRITEEXTHUNK
   
   CONRITEINISH = *
   CLC
   RTS

CONRHKAXEN .BUF 1

CONRITEHUNK = *  ;( CONRITETR, .=DATAEN ) : .=DATARITTEN
   STA CONRHKAXEN
-  SEC
   LDA CONINOLS
   SBC CONUROL
   BNE +
   JSR CONRITEEWLINE
   LDY #0
   LDA (CONRITETR),Y
   CMP #CHR
   BNE -
   LDA #1
   RTS
+  CMP CONRHKAXEN
   BCS +
   STA CONRHKAXEN
+  LDY #0

-  LDA (CONRITETR),Y
   CMP #21
   BCS ++
-  CPY #0
   BNE CONRHKLUSH
   CMP #CHR
   BNE +
   JSR CONRITEEWLINE
   LDA #1
   RTS
+  JSR CONUTCHAR
   LDA #1
   RTS
+  CMP #147
   BEQ -
   INY
   CPY CONRHKAXEN
   BCC --

   CONRHKLUSH = *
   STY CONRHKAXEN
   CLC
   LDA CONINEDDR+0
   ADC CONUROL
   STA SYSWORK+0
   LDA CONINEDDR+1
   ADC #0
   STA SYSWORK+1
   LDA CONRITETR+0
   LDX CONRITETR+1
   STA SYSWORK+2
   STX SYSWORK+3
   STY SYSWORK+5
   LDA CONUTASK
   LDY CONHAROLOR
   LDX SYSWORK+5
   JSR WINPUT
   CLC
   LDA CONUROL
   ADC CONRHKAXEN
   STA CONUROL
   LDA CONRHKAXEN
   RTS

;*** CONEAD( (ZP)=BUF, .=READAXEN ) : .=(ZW)=LEN, .

CONEAD = *
   STA READAXEN+0
   STY READAXEN+1
   LDA #0
   STA READENGTH+0
   STA READENGTH+1
   LDA ZP+0
   LDY ZP+1
   STA READTR+0
   STY READTR+1

CONEADOOP = *
   LDA READENGTH+0
   CMP READAXEN+0
   LDA READENGTH+1
   SBC READAXEN+1
   BCS CONEADXIT
   JSR KEYLINEET
   BCS CONEADOFXIT
   LDY #0
   STA (READTR),Y
   INC READTR+0
   BNE +
   INC READTR+1
+  INC READENGTH+0
   BNE +
   INC READENGTH+1
+  CMP #$0D
   BEQ CONEADXIT
   JMP CONEADOOP

   CONEADXIT = *
   LDA READENGTH+0
   LDY READENGTH+1
   STA ZW+0
   STY ZW+1
   LDX #$FF
   CLC
   RTS

   CONEADOFXIT = *
   LDA #0
   LDY #0
   STA ZW+0
   STY ZW+1
   CLC
   RTS

KEYLINEET = *  ;( KEYLINETR, KEYLINEOUNT ) : .=CHAR, .=EOF
   LDA KEYLINEOUNT
   BNE +
   JSR CONNPUT
   BCS ++
+  LDX KEYLINETR
   INC KEYLINETR
   DEC KEYLINEOUNT
   LDA KEYLINE,X
   CLC
+  RTS

CONARMAVE .BUF 8
CONARMP   .BUF 4
CONARMP   .BUF 2

CONNPUT = *
   LDX #7
-  LDA SYSWORK,X
   STA CONARMAVE,X
   DEX
   BPL -
   LDX #0
   STX KEYLINETR
   STX KEYLINEOS
   STX KEYLINEOUNT
   LDA #$00
   STA CONISTBUFEPLACETR+0
   LDX #3
-  LDA CONISTBUFEPLACETR,X
   STA CONISTBUFCANTR,X
   LDA MP,X
   STA CONARMP,X
   LDA CONISTBUFEPLACETR,X
   STA MP,X
   DEX
   BPL -
   LDA #$06
   STA MP+0
   LDA #0
   STA SYSWORK
   LDX #SYSWORK
   LDY #1
   JSR ZPSTORE
   LDA #$00
   STA MP+0
   LDX #1
-  LDA ZP,X
   STA CONARMP,X
   DEX
   BPL -

   CONNEXT = *
   JSR CONYNCHURSOR
   JSR CONURSORN
   JSR CONETKEY
   JSR CONURSORFF
   CMP #$0D
   BNE +
   JMP CONNETURN
+  CMP #$14  ;BACKSPACE
   BNE +
   JMP CONNACKSPACE
+  CMP #$03  ;STOP
   BEQ CONNEXT
   CMP #147  ;CLEAR
   BNE +
   JMP CONNLEAR
+  CMP #$E4
   BNE +
   LDX KEYLINEOUNT
   BNE +
   JSR CONESTOREARMS
   SEC
   RTS
+  CMP #$F5  ;CT-U
   BNE +
   JMP CONNILL
+  CMP #29  ;RIGHT
   BNE +
   JMP CONNIGHT
+  CMP #157 ;LEFT
   BNE +
   JMP CONNEFT
+  CMP #$10  ;CO-LEFT
   BNE +
-  JMP CONNOL
+  CMP #$EA  ;CT-J
   BEQ -
   CMP #$15  ;CO-RIGHT
   BNE +
-  JMP CONNOL
+  CMP #$EB  ;CT-K
   BEQ -
   CMP #$F2  ;CT-R
   BNE +
   JMP CONNEDISPLAY
+  CMP #145  ;UP
   BNE +
   JMP CONNREVINE
+  CMP #17   ;DOWN
   BNE +
   JMP CONNEXTINE
+  LDX KEYLINEOUNT
   CPX #KEYLINEAX
   BCC +
   JSR CONELL
   JMP CONNEXT
+  PHA
   ;** INSERT SPACE FOR NEW CHAR
   INX
   STX KEYLINEOUNT
-  LDA KEYLINE-1,X
   STA KEYLINE,X
   DEX
   BEQ +
   CPX KEYLINEOS
   BCS -
   BEQ -
+  PLA
   LDX KEYLINEOS
   STA KEYLINE,X
   INC KEYLINEOS
   JSR CONUTCHARIT
   JSR CONNLOSH
   JSR CONNACKUP
   JSR CONNAVEINE
   JMP CONNEXT

CONNETURN = *
   JSR CONNAVEINE
   JSR CONNLOSH
   LDA #CHR
   LDX KEYLINEOUNT
   STA KEYLINE,X
   INC KEYLINEOUNT
   JSR CONUTCHAR
   LDX #0
   STX KEYLINETR
   LDA KEYLINEEN
   BEQ +
   LDX #3
-  LDA CONISTBUFEPLACETR,X
   STA MP,X
   DEX
   BPL -
   LDA #<KEYLINEUF
   LDY #>KEYLINEUF
   STA ZP+0
   STY ZP+1
   LDA #3
   LDY #0
   JSR FETCH
   LDX #2
-  LDA KEYLINEEXT,X
   STA CONISTBUFEPLACETR+1,X
   DEX
   BPL -
+  JSR CONESTOREARMS
   CLC
   RTS

CONNLEAR = *
   JSR CONUTCHAR
   LDA #0
   STA KEYLINEOS
   STA KEYLINEOUNT
   JMP CONNEXT

CONNACKSPACE = *
   LDX KEYLINEOS
   BNE +
   JMP CONNEXT
+  DEC KEYLINEOS
   DEC KEYLINEOUNT
   LDX KEYLINEOS
   JMP +
-  LDA KEYLINE+1,X
   STA KEYLINE,X
   INX
+  CPX KEYLINEOUNT
   BCC -
   JSR CONACKSPACE
   JSR CONNLOSH
   PHA
   LDA #" "
   JSR CONUTCHAR
   PLA
   CLC
   ADC #1
   JSR CONNACKUP
   JSR CONNAVEINE
   JMP CONNEXT

CONNEFT = *
   LDA KEYLINEOS
   BEQ +
   JSR CONACKSPACE
   DEC KEYLINEOS
+  JMP CONNEXT

CONNIGHT = *
   LDX KEYLINEOS
   CPX KEYLINEOUNT
   BEQ +
   LDA KEYLINE,X
   JSR CONUTCHAR
   INC KEYLINEOS
+  JMP CONNEXT

CONNOL = *
   LDA KEYLINEOS
   JSR CONNACKUP
   LDA #0
   STA KEYLINEOS
   JMP CONNEXT

CONNOL = *
   JSR CONNLOSH
   LDA KEYLINEOUNT
   STA KEYLINEOS
   JMP CONNEXT

CONNEDISPLAY = *
   LDA KEYLINEOS
   PHA
   JSR CONNACKUP
   LDA #0
   STA KEYLINEOS
   JSR CONNLOSH
   PLA
   STA KEYLINEOS
   SEC
   LDA KEYLINEOUNT
   SBC KEYLINEOS
   JSR CONNACKUP
   JMP CONNEXT

CONNILL = *
   JSR CONNILLUB
   JMP CONNEXT
CONNILLNT .BUF 1
CONNILLUB = *
   ;** GOTO BEGINNING OF LINE
   LDA KEYLINEOS
   JSR CONNACKUP
   ;** BLANK OUT LINE
   LDA #$FF
   STA CONGNORETRL
   LDA KEYLINEOUNT
   STA CONNILLNT
   BEQ +
-  LDA #" "
   JSR CONUTCHAR
   DEC CONNILLNT
   BNE -
   ;** BACKUP
+  LDA KEYLINEOUNT
   JSR CONNACKUP
   LDA #$00
   STA CONGNORETRL
   ;** INTERNAL
   LDA #0
   STA KEYLINEOS
   STA KEYLINEOUNT
   RTS

CONLOSHTR .BUF 1

CONNLOSH = *  ;( ) : COUNT ;SLOSH OUT LINE FROM KEYLINEOS TO KEYLINEOUNT
   LDA #$FF
   STA CONGNORETRL
   LDA KEYLINEOS
   STA CONLOSHTR
-  LDX CONLOSHTR
   CPX KEYLINEOUNT
   BCS +
   LDA KEYLINE,X
   JSR CONUTCHARIT
   INC CONLOSHTR
   JMP -
+  LDA #$00
   STA CONGNORETRL
   SEC
   LDA KEYLINEOUNT
   SBC KEYLINEOS
   RTS

CONACKUPOUNT .BUF 1

CONNACKUP = *  ;( .=COUNT ) ;BACKUP THE CURSOR . SPACES
   STA CONACKUPOUNT
   CMP #0
   BEQ +
-  LDA #CHR
   JSR CONUTCHAR
   DEC CONACKUPOUNT
   BNE -
+  RTS

CONESTOREARMS = *
   LDX #7
-  LDA CONARMAVE,X
   STA SYSWORK,X
   DEX
   BPL -
   LDX #3
-  LDA CONARMP,X
   STA MP,X
   DEX
   BPL -
   LDX #1
-  LDA CONARMP,X
   STA ZP,X
   DEX
   BPL -
   RTS

CONNEXTINE = *
   ;** LOCATE NEXT SCAN LINE
   LDA CONISTBUFEPLACETR+3
   CMP #ACEEMULL
   BEQ +
   JSR CONNINEETCHEAD
   LDX #2
-  LDA CONISTBUFCANTR+1,X
   CMP CONISTBUFEPLACETR+1,X
   BNE ++
   DEX
   BPL -
+  JMP CONNEXT
+  LDX #2
-  LDA KEYLINEEXT,X
   STA CONISTBUFCANTR+1,X
   STA MP+1,X
   DEX
   BPL -
   JMP +++
   
CONNREVINE = *
   ;** LOCATE PREVIOUS SCAN LINE
   LDA CONISTBUFEPLACETR+3
   CMP #ACEEMULL
   BEQ +
   JSR CONNINEETCHEAD
   LDX #2
-  LDA KEYLINEREV,X
   CMP CONISTBUFEPLACETR+1,X
   BNE ++
   DEX
   BPL -
+  JSR CONELL
   JMP CONNEXT
+  LDX #2
-  LDA KEYLINEREV,X
   STA CONISTBUFCANTR+1,X
   STA MP+1,X
   DEX
   BPL -
+  LDA #$00
   STA MP+0
   ;** UNDISPLAY CURRENT LINE
   JSR CONNILLUB
   ;** FETCH NEW LINE
   LDA #<256
   LDY #>256
   JSR FETCH
   ;** DISPLAY NEW LINE
   LDA #0
   STA KEYLINEOS
   LDA KEYLINEEN
   STA KEYLINEOUNT
   JSR CONNLOSH
   LDA KEYLINEOUNT
   STA KEYLINEOS
   JMP CONNEXT

CONNINEETCHEAD = *
   LDX #3
-  LDA CONISTBUFCANTR,X
   STA MP,X
   DEX
   BPL -
   LDA #<KEYLINEUF
   LDY #>KEYLINEUF
   STA ZP+0
   STY ZP+1
   LDA #6
   LDY #0
   JSR FETCH
   RTS

CONNAVEINE = *
   LDA CONISTBUFEPLACETR+3
   CMP #ACEEMULL
   BNE +
   RTS
+  LDA KEYLINEOUNT
   STA KEYLINEEN
   LDX #3
-  LDA CONISTBUFEPLACETR,X
   STA MP,X
   DEX
   BPL -
   LDA #$06
   STA MP+0
   LDA #<KEYLINEUF+6
   LDY #>KEYLINEUF+6
   STA ZP+0
   STY ZP+1
   CLC
   LDA KEYLINEOUNT
   ADC #2
   LDY #0
   JSR STASH
   LDA #$00
   STA MP+0
   RTS

CONACKSPACE = *
   DEC CONUROL
   BPL +
   LDX CONINOLS
   DEX
   STX CONUROL
   LDA CONUROW
   BEQ +
   DEC CONUROW
   SEC
   LDA CONINEDDR+0
   SBC CONOWNC+0
   STA CONINEDDR+0
   LDA CONINEDDR+1
   SBC CONOWNC+1
   STA CONINEDDR+1
+  RTS

CONURSORN = *  ;( )
   JSR CONETURSORDDR
   LDY CONURSOROLOR
   LDA #$FF
   JSR WINCURSOR
   RTS

CONURSORFF = *  ;( )  ;. PRESERVED
   PHA
   JSR CONETURSORDDR
   LDA #0
   JSR WINCURSOR
   PLA
   RTS

CONOLOR = *
   STA SYSWORK+15
   AND #$02
   BEQ +
   STX CONHAROLOR
+  LDA SYSWORK+15
   AND #$01
   BEQ +
   STY CONURSOROLOR
+  LDX CONHAROLOR
   LDY CONURSOROLOR
   RTS

CONALETTE = *
   LDY #0
   BIT TEXTODE
   BMI +
   LDY #8
+  LDX #0
-  NOP
   .IF COMPUTER-64
   LDA CONFIGUF+$B0,Y
   .ELSE
   LDA CONFIGUF+$D0,Y
   .IFE
   STA SYSWORK+0,X
   INY
   INX
   CPX #8
   BCC -
   RTS

CONCREEN = *
   ;** CHECK SPECIAL SIZES
   CMP #0
   BNE +
-  LDA #25
+  CMP #255
   BEQ -
   CPX #0
   BNE +
   LDX #40
   BIT TEXTODE
   BPL +
   LDX #80
+  CPX #255
   BNE +
   LDX #80   ;CHANGE FOR 64 WITHOUT SOFT 80-COL SUPPORT
   ;** CHECK SCREEN LIMITS
+  CMP #26
   BCC +
-  LDA #ACERRNVALIDONARMS
   STA ERRNO
   SEC
   RTS
+  CPX #81
   BCS -
   ;** SET SCREEN
   LDY #$00
   CPX #40+1
   BCC +
   LDY #$80
+  STY TEXTODE
.IF COMPUTER-64
   ;** 128-SET FAST/SLOW
   CPY #0
   BEQ +
   LDA VIC+$11
   AND #%01101111
   STA VIC+$11
   LDA #1
   STA VIC+$30
   JMP ++
+  LDA #0
   STA VIC+$30
   LDA VIC+$11
   AND #%01111111
   ORA #%00010000
   STA VIC+$11
+  NOP
.ELSE
   ;** 64-INITIALIZE SCREEN HARDWARE
   CPY #$00
   BNE +
   JSR VICNIT
   JMP ++
+  JSR VDCNIT
+  NOP
.IFE
   ;** CHANGE COLORS
   JSR CONPALETTE
   LDX SYSWORK+0
   LDY SYSWORK+1
   LDA #$23
   JSR CONCOLOR
   JSR CONPALETTE
   LDX SYSWORK+7
   LDY SYSWORK+6
   LDA #$C0
   JSR WINCOLOR
   ;** WINDOW PARMS
   JSR WINMAX
   JSR CONINNIT
   LDA CONINOWS
   LDX CONINOLS
   CLC
   RTS

CONOS = *
   CMP CONINOWS
   BCC +
-  LDA #ACERRNVALIDONARMS
   STA ERRNO
   SEC
   RTS
+  CPX CONINOLS
   BCS -
   STA CONUROW
   STX CONUROL
   LDX #0
   JSR WINPOS
   LDA SYSWORK+0
   LDY SYSWORK+1
   STA CONINEDDR+0
   STY CONINEDDR+1
   CLC
   RTS

;3-EY OLLOVER-128 BY RAIG RUCE 18-UN-93 FROM = ACKING MAGAZINE

.IF COMPUTER-64
   SCANROWS = 11
   PK = $D02F
   NEWPOS = $CC
   KEYCODE = $D4
   PREVEYCODE = $D5
   XSAVE = $CD
   MASK = $CC
   CAPSORT = $0001
   KEYMAPTR = $CC
.ELSE
   SCANROWS = 8
   PK .BUF 1  ;DUMMY
   NEWPOS = $F5
   KEYCODE = $CB
   PREVEYCODE = $C5
   XSAVE = $F6
   MASK = $F5
   CAPSORT .BYTE $40
   KEYMAPTR = $F5
.IFE
STOPEYOW .BUF 1
ROLLOVER = 3
NULLEY = $FF

PA = $DC00
PB = $DC01

CONRQEYSCAN = *
   LDA SCROLLOUNTDOWN
   BEQ +
   DEC SCROLLOUNTDOWN
+  LDA #0
   STA PA
   STA PK
-  LDA PB
   CMP PB
   BNE -
   CMP #$FF
   BEQ NOEYRESSED

   JSR CHECKOYSTICK
   BCC NOEYRESSED
   JSR KEYSCAN
   JSR CHECKOYSTICK
   BCC NOEYRESSED
   LDA SCANABLE+7
   STA STOPEYOW
   JSR SELECTOUSE
   JSR SHIFTDECODE
   JSR KEYDECODE
   JSR CONCREENNSAVE
   JSR KEYORDER
   BIT IGNOREEYS
   BMI +
   LDA PREVEYS+0
   CMP #NULLEY
   BEQ +
   STA KEYCODE
   JMP INTERPEY

   NOEYRESSED = *
   JSR SELECTOUSE
   LDA #NULLEY
   LDX #ROLLOVER-1
-  STA PREVEYS,X
   DEX
   BPL -
   JSR SCANAPS
   LDA #0
   STA IGNOREEYS
   STA STOPEYOW

+  LDA #NULLEY
   STA KEYCODE
   STA PREVEYCODE
   RTS

SELECTOUSE = *
   LDA #$FF
   STA PK
   LDA #$7F  ;SELECTS PADDLE/MOUSE 
   STA PA
   RTS

KEYSCANNIT = *
   LDA #NULLEY
   LDX #ROLLOVER-1
-  STA PREVEYS,X
   DEX
   BPL -
   LDA #0
   STA IGNOREEYS
   RTS

KEYSCAN = *
.IF COMPUTER-64
   LDX #$FF
   LDY #$FF
   LDA #$FE
   STA MASK+0
   LDA #$FF
   STA MASK+1
   JMP +
   NEXTOW = *
-  LDA PB
   CMP PB
   BNE -
   STY PA
   STY PK
   EOR #$FF
   STA SCANABLE,X
   SEC
   ROL MASK+0
   ROL MASK+1
+  LDA MASK+0
   STA PA
   LDA MASK+1
   STA PK
   INX
   CPX #SCANROWS
   BCC NEXTOW
   RTS
.ELSE
   LDX #$FF
   LDY #$FF
   LDA #$FE
   STA MASK
   JMP +
   NEXTOW = *
-  LDA PB
   CMP PB
   BNE -
   STY PA
   EOR #$FF
   STA SCANABLE,X
   SEC
   ROL MASK
+  LDA MASK
   STA PA
   INX
   CPX #SCANROWS
   BCC NEXTOW
   RTS
.IFE

SHIFTOWS .BYTE $01,$06,$07,$07,$0A
SHIFTITS .BYTE $80,$10,$20,$04,$01
SHIFTASK .BYTE $01,$01,$02,$04,$08

SHIFTDECODE = *
   JSR SCANAPS
.IF COMPUTER-64
   LDY #4
.ELSE
   LDY #3
.IFE
-  LDX SHIFTOWS,Y
   LDA SCANABLE,X
   AND SHIFTITS,Y
   BEQ +
   LDA SHIFTASK,Y
   ORA SHIFTALUE
   STA SHIFTALUE
   LDA SHIFTITS,Y
   EOR #$FF
   AND SCANABLE,X
   STA SCANABLE,X
+  DEY
   BPL -
   RTS

SCANAPS = *
-  LDA CAPSORT
   CMP CAPSORT
   BNE -
   EOR #$FF
   AND #$40
   LSR
   LSR
   STA SHIFTALUE
   RTS

KEYDECODE = *
   LDX #ROLLOVER-1
   LDA #$FF
-  STA NEWEYS,X
   DEX
   BPL -
   LDY #0
   STY NEWPOS
   LDX #0
   STX KEYCODE

   DECODEEXTOW = *
   LDA SCANABLE,X
   BEQ DECODEONTINUE

   LDY KEYCODE
-  LSR
   BCC ++
   PHA
   STX XSAVE
   LDX NEWPOS
   CPX #ROLLOVER
   BCS +
   TYA
   STA NEWEYS,X
   INC NEWPOS
+  LDX XSAVE
   PLA
+  INY
   CMP #$00
   BNE -

   DECODEONTINUE = *
   CLC
   LDA KEYCODE
   ADC #8
   STA KEYCODE
   INX
   CPX #SCANROWS
   BCC DECODEEXTOW
   RTS

KEYORDER = *
   ;** REMOVE OLD KEYS NO LONGER HELD
   LDY #0
   NEXTEMOVE = *
   LDA PREVEYS,Y
   CMP #$FF
   BEQ ++
   LDX #ROLLOVER-1
-  CMP NEWEYS,X
   BEQ +
   DEX
   BPL -
   TYA
   TAX
-  LDA PREVEYS+1,X
   STA PREVEYS+0,X
   INX
   CPX #ROLLOVER-1
   BCC -
   LDA #$FF
   STA PREVEYS+ROLLOVER-1
   STA IGNOREEYS
+  INY
   CPY #ROLLOVER
   BCC NEXTEMOVE

   ;** INSERT NEW KEY AT FRONT
+  LDY #0
   NEXTNSERT = *
   LDA NEWEYS,Y
   CMP #$FF
   BEQ ++
   LDX #ROLLOVER-1
-  CMP PREVEYS,X
   BEQ +
   DEX
   BPL -
   PHA
   LDX #ROLLOVER-2
-  LDA PREVEYS+0,X
   STA PREVEYS+1,X
   DEX
   BPL -
   LDA #0
   STA IGNOREEYS
   PLA
   STA PREVEYS+0
   LDY #ROLLOVER
+  INY
   CPY #ROLLOVER
   BCC NEXTNSERT
+  RTS

CHECKOYSTICK = *
   LDA #$FF
   STA PA
   STA PK
-  LDA PB
   CMP PB
   BNE -
   CMP #$FF
   RTS

SCANABLE  .BUF SCANROWS
NEWEYS    .BUF ROLLOVER
IGNOREEYS .BUF 1
PREVEYS   .BUF ROLLOVER+2

SCROLLREEZE    .BYTE $00
DELAYOUNTDOWN  .BYTE $00
REPEATOUNTDOWN .BYTE $00
SCROLLOUNTDOWN .BYTE $00

INTERPEY = *  ;( KEYCODE )
   LDA KEYCODE
   ;** NOSCROLL
.IF COMPUTER-64
   CMP #87      ;NOSCROLL
   BNE INTERPAPS
.ELSE
   CMP #63      ;RUN/STOP
   BNE INTERPAPS
   LDA SHIFTALUE
   AND #%1111
   CMP #4       ;CONTROL
   BNE INTERPAPS
   LDA KEYCODE
.IFE
   CMP PREVEYCODE
   BEQ +
   STA PREVEYCODE
   LDA SCROLLREEZE
   EOR #$FF
   STA SCROLLREEZE
+  RTS

   INTERPAPS = *
.IF COMPUTER-64
.ELSE
   LDA KEYCODE
   CMP #63      ;RUN/STOP
   BNE INTERPHIFTS
   LDA SHIFTALUE
   AND #%1111
   CMP #2       ;COMMODORE
   BNE INTERPHIFTS
   LDA KEYCODE
   CMP PREVEYCODE
   BEQ +
   STA PREVEYCODE
   LDA CAPSORT
   EOR #$40
   STA CAPSORT
+  RTS
.IFE

   INTERPHIFTS = *
   LDA SHIFTALUE
   AND #%00011111
   CMP #%00010000
   BNE +
   LDA #5
   JMP HANDLEEY  ;CAPS
+  AND #%1111
   TAX
   LDA SHIFTRIEC,X
   JMP HANDLEEY

SHIFTRIEC = *
.IF COMPUTER-64
;          0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15
   .BYTE $00,$01,$02,$02,$03,$03,$03,$03,$04,$04,$04,$04,$04,$04,$04,$04
.ELSE
   .BYTE $00,$01,$02,$02,$03,$03,$04,$04,$04,$04,$04,$04,$04,$04,$04,$04
.IFE

HANDLEEY = * ;( KEYCODE, .=SHIFTABLEUM )
   ASL
   TAX
   LDA KEYCODE
   CMP PREVEYCODE
   BEQ HANDLEEPEAT
   JMP HANDLERIGEY

HANDLEEPEAT = *
   STX XSAVE
   LDA DELAYOUNTDOWN
   BEQ +
   DEC DELAYOUNTDOWN
   BEQ ++
   RTS
+  DEC REPEATOUNTDOWN
   BEQ +
-  RTS
+  LDA CONFIGUF+$C9
   STA REPEATOUNTDOWN
   LDA KEYBUFOUNT
   BNE -
   LDX XSAVE
   JMP +

HANDLERIGEY = * ;( .=SHIFTABFF )
   LDA CONFIGUF+$C8
   STA DELAYOUNTDOWN
   LDA #0
   STA SCROLLREEZE
+  LDA CONEYMAPNDIRECT+0,X
   STA KEYMAPTR+0
   LDA CONEYMAPNDIRECT+1,X
   STA KEYMAPTR+1
   LDY KEYCODE
   STY PREVEYCODE
   LDA (KEYMAPTR),Y
   BNE STOREEY
   RTS

KEYBUFEAD  .BYTE 0
KEYBUFAIL  .BYTE 0
KEYBUFOUNT .BYTE 0
KEYBUFIZE  = 32  ;POWER OF 2
KEYBUFATA  .BUF KEYBUFIZE

STOREEY = *  ;( .=CHAR )
   LDX KEYBUFOUNT
   CPX #KEYBUFIZE
   BCC +
   ;XX RING BELL
   RTS
+  LDX KEYBUFAIL
   STA KEYBUFATA,X
   INC KEYBUFAIL
   LDA KEYBUFAIL
   AND #KEYBUFIZE-1
   STA KEYBUFAIL
   INC KEYBUFOUNT
   RTS

;*** GETKEY( ) : .=KEYHAR

CONETKEY = *
   PHP
-  CLI
   LDA KEYBUFOUNT
   BEQ -
   SEI
   LDX KEYBUFEAD
   DEC KEYBUFOUNT
   INC KEYBUFEAD
   LDA KEYBUFEAD
   AND #KEYBUFIZE-1
   STA KEYBUFEAD
   LDA KEYBUFATA,X
   PLP
   RTS

;*** CONKEYAVAIL( ) : .=.=KEYSVAILABLE, .=AVAILEY[NOTEMOVED]
CONEYVAIL = *
   LDA KEYBUFOUNT
   BEQ +
   LDX KEYBUFEAD
   LDA KEYBUFATA,X
   LDX #$00
   CLC
   RTS
+  LDA #$00
   LDX #$FF
   SEC
   RTS
   
;*** STOPKEY( ) : .=NOTRESSED

ACETOPEY = *
   LDA STOPEYOW
   CMP #$80
   BEQ +
-  CLC
   RTS
+  LDA SHIFTALUE
   AND #$0F
   BNE -
   LDA #0
   STA KEYBUFOUNT
   STA KEYBUFEAD
   STA KEYBUFAIL
   STA SCROLLREEZE
   LDA #ACERRTOPPED
   STA ERRNO
   SEC
   RTS

CONEYMAPNDIRECT = *
   .WORD CONEYMAPORMAL,CONEYMAPHIFT,CONEYMAPOMMODORE,CONEYMAPONTROL
   .WORD CONEYMAPLTERNATE,CONEYMAPAPS

CONEYMAPORMAL = *
   .BYTE $14,$0D,$1D,$88,$85,$86,$87,$11,$0033,$57,$41,$34,$5A,$53,$45,$01
   .BYTE $35,$52,$44,$36,$43,$46,$54,$58,$0037,$59,$47,$38,$42,$48,$55,$56
   .BYTE $39,$49,$4A,$30,$4D,$4B,$4F,$4E,$002B,$50,$4C,$2D,$2E,$3A,$40,$2C
   .BYTE $5C,$2A,$3B,$13,$01,$3D,$5E,$2F,$0031,$5F,$04,$32,$20,$02,$51,$03
   .BYTE $84,$38,$35,$09,$32,$34,$37,$31,$001B,$2B,$2D,$0A,$0D,$36,$39,$33
   .BYTE $08,$30,$2E,$91,$11,$9D,$1D,$00

CONEYMAPHIFT = *
   .BYTE $94,$8D,$9D,$8C,$89,$8A,$8B,$91,$0023,$D7,$C1,$24,$DA,$D3,$C5,$01
   .BYTE $25,$D2,$C4,$26,$C3,$C6,$D4,$D8,$0027,$D9,$C7,$28,$C2,$C8,$D5,$D6
   .BYTE $29,$C9,$CA,$30,$CD,$CB,$CF,$CE,$00DB,$D0,$CC,$DD,$3E,$5B,$BA,$3C
   .BYTE $DC,$C0,$5D,$93,$01,$3D,$DE,$3F,$0021,$DF,$04,$22,$20,$02,$D1,$83
   .BYTE $04,$38,$35,$02,$32,$34,$37,$31,$001B,$2B,$2D,$0A,$8D,$36,$39,$33
   .BYTE $08,$30,$2E,$16,$17,$06,$0B,$00

CONEYMAPOMMODORE = *
   .BYTE $08,$0D,$9D,$8F,$80,$82,$84,$91,$0096,$B7,$A1,$97,$BA,$B3,$A5,$01
   .BYTE $98,$B2,$A4,$99,$A3,$A6,$B4,$B8,$009A,$B9,$A7,$9B,$A2,$A8,$B5,$B6
   .BYTE $29,$A9,$AA,$30,$AD,$AB,$AF,$AE,$00A6,$B0,$AC,$7C,$3E,$BB,$A0,$3C
   .BYTE $BC,$7F,$BD,$93,$01,$BF,$BE,$3F,$0081,$BF,$04,$95,$5F,$02,$B1,$03
   .BYTE $04,$38,$35,$18,$32,$34,$37,$31,$001B,$2B,$2D,$0A,$8D,$36,$39,$33
   .BYTE $08,$30,$2E,$0C,$0F,$10,$15,$00

CONEYMAPONTROL = *
   .BYTE $08,$00,$00,$8F,$80,$82,$84,$00,$001C,$F7,$E1,$9F,$FA,$F3,$E5,$00
   .BYTE $9C,$F2,$E4,$1E,$E3,$E6,$F4,$F8,$001F,$F9,$E7,$9E,$E2,$E8,$F5,$F6
   .BYTE $12,$E9,$EA,$92,$ED,$EB,$EF,$EE,$007B,$F0,$EC,$7D,$00,$FB,$E0,$00
   .BYTE $FC,$60,$FD,$00,$00,$FF,$FE,$00,$0090,$FF,$00,$05,$20,$00,$F1,$00
   .BYTE $04,$8C,$87,$18,$89,$8A,$88,$85,$001B,$84,$8F,$0A,$00,$8B,$80,$86
   .BYTE $08,$82,$2E,$16,$17,$19,$1A,$00

CONEYMAPLTERNATE = *
   .BYTE $08,$0D,$1D,$88,$85,$86,$87,$11,$0033,$77,$61,$34,$7A,$73,$65,$00
   .BYTE $35,$72,$64,$36,$63,$66,$74,$78,$0037,$79,$67,$78,$62,$68,$75,$76
   .BYTE $39,$69,$6A,$30,$6D,$6B,$6F,$6E,$007B,$70,$6C,$7D,$2E,$7B,$BA,$2C
   .BYTE $A9,$60,$7D,$13,$00,$7F,$7E,$2F,$0031,$7F,$04,$32,$20,$02,$71,$03
   .BYTE $04,$38,$35,$09,$32,$34,$37,$31,$001B,$2B,$2D,$0A,$0D,$36,$39,$33
   .BYTE $08,$30,$2E,$91,$11,$9D,$1D,$00

CONEYMAPAPS = *
   .BYTE $14,$0D,$1D,$88,$85,$86,$87,$11,$0033,$D7,$C1,$34,$DA,$D3,$C5,$01
   .BYTE $35,$D2,$C4,$36,$C3,$C6,$D4,$D8,$0037,$D9,$C7,$38,$C2,$C8,$D5,$D6
   .BYTE $39,$C9,$CA,$30,$CD,$CB,$CF,$CE,$002B,$D0,$CC,$2D,$2E,$3A,$40,$2C
   .BYTE $5C,$2A,$3B,$13,$01,$3D,$5E,$2F,$0031,$5F,$04,$32,$20,$02,$D1,$03
   .BYTE $04,$38,$35,$09,$32,$34,$37,$31,$001B,$2B,$2D,$0A,$0D,$36,$39,$33
   .BYTE $08,$30,$2E,$91,$11,$9D,$1D,$00

CONSOUNTDOWN .BYTE 1
CONIFSERIN = 3600
CONSINUTE .WORD CONIFSERIN
CONSAX .BYTE 1
CONSCTIVE .BYTE $00

CONCREENAVE = *
   LDA CONSOUNTDOWN
   BNE +
-  RTS
+  LDA CONSINUTE+0
   BNE +
   DEC CONSINUTE+1
+  DEC CONSINUTE+0
   LDA CONSINUTE+0
   ORA CONSINUTE+1
   BNE -
   LDA #<CONIFSERIN
   LDY #>CONIFSERIN
   STA CONSINUTE+0
   STY CONSINUTE+1
   DEC CONSOUNTDOWN
   BNE -
   JSR VDCCREENAVE
   JSR VICCREENAVE
   LDA #$FF
   STA CONSCTIVE
   RTS

CONCREENNSAVE = *
   LDA CONSAX
   STA CONSOUNTDOWN
   LDA #<CONIFSERIN
   LDY #>CONIFSERIN
   STA CONSINUTE+0
   STY CONSINUTE+1
   LDA CONSCTIVE
   BNE +
   RTS
+  JSR VDCCREENNSAVE
   JSR VICCREENNSAVE
   LDA #$00
   STA CONSCTIVE
   RTS

;HIS IS TO BE DONE WHEN WE ARE IN THE WRITE ROUTINE ABOUT TO SCROLL THE SCREEN
;BECAUSE WE HAVE HIT THE BOTTOM LINE OF THE DISPLAY.  T IS ALSO TO BE DONE IN
;THE CONTEXT OF THE DATA REMAINING TO BE PRINTED AT THE TIME.

CONINESOCROLL .BUF 1
CONYTESOCROLL .BUF 2
CONCANTR = SYSWORK+14 ;(2)
CONOLUMBER .BUF 1
CONAXRESCROLL .BUF 1

CONRITEEWLINE = *
   LDA SHIFTALUE
   AND #$07
   BEQ +
-  JMP CONEWLINE
+  LDX CONUROW
   INX
   CPX CONINOWS
   BCC -

;FIND MAXIMUM PRESCROLL AMOUNT;
;IF MAXIMUM PRESCROLL AMOUNT < 2 THEN NEVER MIND;
;LINES_TO_SCROLL := 1;
;BYTES_TO_SCROLL := SCREEN_WIDTH;
;SCAN_POINTER := DISPLAY_DATA_PTR;
;COL_NUMBER := 0;

.IF COMPUTER-64
   LDA CONFIGUF+$AC
   BIT TEXTODE ;%%%
   BMI CONRESCROLLEGIN
   LDA CONFIGUF+$AD
.ELSE
   LDA CONFIGUF+$40
   BIT TEXTODE
   BPL CONRESCROLLEGIN
   LDA CONFIGUF+$AE
   LDX VDCCROLLEUORK+3
   CPX #ACEEMULL
   BEQ CONRESCROLLEGIN
   LDA CONFIGUF+$AB
.IFE
   CONRESCROLLEGIN = *
   STA CONAXRESCROLL
   CMP #2
   BCS +
   JMP CONEWLINE
+  LDA #1
   STA CONINESOCROLL
   LDA #0 ;CONOWNC+0
   LDY #0 ;CONOWNC+1
   STA CONYTESOCROLL+0
   STY CONYTESOCROLL+1
   LDA #0
   STA CONOLUMBER
   INC CONUROW

;REPEAT:
;IF CHAR == NEWLINE GOTO LINESCROLLED;
;IF COL_NUMBER > LINE_WIDTH  LINESCROLLED;
;IF CHAR == NORMAL THEN COL_NUMBER += 1; GOTO NEXTCHAR;
;IF CHAR == CLEAR GOTO EXIT;  OPTIONAL
;IF CHAR == TAB THEN COL_NUMBER += 8 - COL_NUMBER%8; GOTO NEXTCHAR;  OPTIONAL
;IF CHAR == BELL GOTO NEXTCHAR;
;IF CHAR == RETURN THEN COL_NUMBER := 0; GOTO NEXTCHAR;
;IF CHAR == BACKSPACE THEN
;    COL_NUMBER -= 1;
;    IF COL_NUMBER < 0 THEN COL_NUMBER = 0;
;    GOTO NEXTCHAR;
;ENDIF
;BRK;
CONRESCROLLEPEAT = *
   JMP CONINECROLLED

;LINESCROLLED:
;COL_NUMBER := 0;
;LINES_TO_SCROLL += 1;
;BYTES_TO_SCROLL += LINE_INC;
;IF LINES_TO_SCROLL >= MAXIMUM_PRESCROLL GOTO EXIT;
CONINECROLLED = *
   JSR CONINECROLLEDUB
   BCC CONRESCROLLEXTHAR
   BCS CONRESCROLLXIT
CONINECROLLEDUB = *
   LDA #0
   STA CONOLUMBER
   INC CONINESOCROLL
   CLC
   LDA CONYTESOCROLL+0
   ADC CONOWNC+0
   STA CONYTESOCROLL+0
   BCC +
   INC CONYTESOCROLL+1
+  LDA CONINESOCROLL
   CMP CONAXRESCROLL
   RTS

;NEXTCHAR:
;SCAN POINTER++;
;IF SCAN POINTER < SCAN LIMIT GOTO REPEAT;
CONRESCROLLEXTHAR = *
   JMP CONRESCROLLEPEAT

;EXIT:
;SCROLL SCREEN BY LINES_TO_SCROLL;
;SUBTRACT BYTES_TO_SCROLL FROM LINE ADDRESS;
;LINE_COL := 0;
;LINE_ROW -= LINES_TO_SCROLL;
CONRESCROLLXIT = *
   LDA #" "
   STA SYSWORK+4
   LDA CONUTASK
   ORA #$08
   LDX CONINESOCROLL
   LDY CONHAROLOR
   JSR WINSCROLL
   SEC
   LDA CONUROW
   SBC CONINESOCROLL
   STA CONUROW
   SEC
   LDA CONINEDDR+0
   SBC CONYTESOCROLL+0
   STA CONINEDDR+0
   LDA CONINEDDR+1
   SBC CONYTESOCROLL+1
   STA CONINEDDR+1
   LDA #0
   STA CONUROL
   RTS

;THE END + BLANK LINE

