;===ACE SYSTEM INTERFACE DECLARATIONS===

ZP      = $F8  ;(2)
ZW      = $FA  ;(2)
MP      = $FC  ;(4)
SYSWORK = $80  ;(16)

ACETAT         = $F00
ERRNO            = ACETAT+0          ;(1)
ACE            = ACETAT+2          ;(2)
ACERGC          = ACETAT+4          ;(2)
ACERGV          = ACETAT+6          ;(2)
ACEEMOP        = ACETAT+8          ;(2)
ACEHELLATH     = $C00                ;(256)
ACEHELLLIAS    = $D00                ;(256)
ACEURIRAME    = ACETAT+$80        ;(128)
ACEXITATA      = $E00                ;(256)
ACEIRENTUFFER  = ACETAT+10         ;(ACEIRENTENGTH)
ACEIRENTYTES   = ACEIRENTUFFER+0   ;(4)
ACEIRENTATE    = ACEIRENTUFFER+4   ;(8) = :::::::
ACEIRENTYPE    = ACEIRENTUFFER+12  ;(4)
ACEIRENTLAGS   = ACEIRENTUFFER+16  ;(1) = DRWX*E-T
ACEIRENTSAGE   = ACEIRENTUFFER+17  ;(1) = ULSHB---
ACEIRENTAMEEN = ACEIRENTUFFER+18  ;(1)
ACEIRENTAME    = ACEIRENTUFFER+19  ;(17)
ACEIRENTENGTH  = 36

ACEALL  = $2803
OPEN      = ACEALL+0   ;( (ZP)=AME, .=ODE ) : .=FD
CLOSE     = ACEALL+3   ;( .=FD )
READ      = ACEALL+6   ;( .=FD, (ZP)=UF, .=EN ) : .=(ZW)=EN, .
WRITE     = ACEALL+9   ;( .=FD, (ZP)=UF, .=EN )
FASTOPEN  = ACEALL+12  ;( (ZP)=AME, .=ODE ) : .=FD
FASTCLOSE = ACEALL+15  ;( .=FD )
FASTREAD  = ACEALL+18  ;( .=FD, (ZP)=UF, .=EN ) : .=(ZW)=EN, .
BLOAD     = ACEALL+21  ;( (ZP)=AME, .=OADDDR, (ZW)=IMIT+1 ) : .=ND+1
REMOVE    = ACEALL+24  ;( (ZP)=AME )
RENAME    = ACEALL+27  ;( (ZP)=LDAME, (ZW)=EWAME )
DEVINFO   = ACEALL+30  ;( .=FD ) : .=EVYPE, .=OLS, .=OWS
FDSWAP    = ACEALL+33  ;( .=FD1, .=FD2 )

DIROPEN   = ACEALL+36  ;( (ZP)=IRAME ) : .=FD
DIRCLOSE  = ACEALL+39  ;( .=FD )
DIRREAD   = ACEALL+42  ;( .=FD ) : DIRENTUFFER, .=EOF
ISDIR     = ACEALL+45  ;( (ZP)=AME ) : .=EV, .=ISISK, .=ISIR
CHDIR     = ACEALL+48  ;( (ZP)=IRAME )
CDHOME    = ACEALL+51  ;( )
MKDIR     = ACEALL+54  ;( (ZP)=EWIRAME )
RMDIR     = ACEALL+57  ;( (ZP)=IRAME )

ZPLOAD    = ACEALL+60  ;( [MP]=OURCE, .=PEST, .=ENGTH )
ZPSTORE   = ACEALL+63  ;( .=POURCE, [MP]=EST, .=ENGTH )
FETCH     = ACEALL+66  ;( [MP]=AROURCE, (ZP)=AM0EST, .=ENGTH )
STASH     = ACEALL+69  ;( (ZP)=AM0OURCE, [MP]=AREST, .=LENGTH )
PAGEALLOC = ACEALL+72  ;( .=AGEOUNT, .=TARTYP, .=NDYP ) : [MP]=ARTR
PAGEFREE  = ACEALL+75  ;( [MP]=AROINTER, .=AGEOUNT )

WINMAX    = ACEALL+78  ;( )
WINCLS    = ACEALL+81  ;( .=CHAR/COLOR/ATTRLAGS, .=CHAR, .=COLOR )
WINSET    = ACEALL+84  ;( .=ROWS, .=COLS, SW+0=SCROW, SW+1=SCROL )
WINSIZE   = ACEALL+87  ;( ) : <ABOVE>+ ,(SW+2)=ADDR,(SW+4)=ROWINC
WINPUT    = ACEALL+90  ;( (SW+0)=ADDR,(SW+2)=CHARTR,.=ATTR,.=COLOR,.=LEN
                            ;  SW+4=FILLHAR, SW+5=FIELDEN )
WINCOLOR  = ACEALL+93  ;( .=SCREEN, .=BORDER, .=WHICH ) : .=SCR, .=BOR
WINPOS    = ACEALL+96  ;( .=ROW, .=COL ) : (SW+0)=ADDR
WINCURSOR = ACEALL+99  ;( (SW+0)=ADDR, .=COLOR, .=$FF:ON/$00:OFF)
WINSCROLL = ACEALL+102 ;( .=ATTR+$08:UP+$04:DOWN,.=ROWS,SW+4=CHAR,.=COLOR)

CONREAD   = ACEALL+105 ;( (ZP)=UF, .=EN ) : .=(ZW)=EN, .
CONWRITE  = ACEALL+108 ;( (ZP)=UF, .=EN )
CONPUTCHAR = ACEALL+111 ;( .=CHAR )
CONPUTLIT = ACEALL+114 ;( .=CHAR )
STOPKEY   = ACEALL+117 ;( ) : .=NOTRESSED
GETKEY    = ACEALL+120 ;( ) : .=KEY
CONCOLOR  = ACEALL+123 ;( .=WHICH, .=CHAR, .=CURSOR ) : .=CHAR,.=CURSR
CONPALETTE = ACEALL+126 ;( ) : SW+0...SW+7=PALETTE [8 COLORS]
CONSCREEN = ACEALL+129 ;( .=INOWS, .=INOLS )
CONPOS    = ACEALL+132 ;( .=ROW, .=COL )

EXEC      = ACEALL+135 ;( (ZP)=EXECAME, (ZW)=ARGV, .=ARGNT, [MP]=SAVEREA)
                           ;  : .=EXITODE, .=EXITATAEN, [MP]=SAVEREA
EXECSUB   = ACEALL+138 ;( (ZP)=EXECDDR, (ZW)=ARGV, .=ARGNT, [MP]=SAVEREA)
                           ;  : .=EXITODE, .=EXITATAEN, [MP]=SAVEREA
EXIT      = ACEALL+141 ;( .=EXITODE, .=EXITUFATAEN, EXITATA )
MEMSTAT   = ACEALL+144 ;( ) : .=PROC, [SW+0]=TOTAL, [SW+4]=FREE

UTOA      = ACEALL+147 ;( $0+=VALUE32, (SW+0)=BUF, .=MINEN ) :BUF, .=LEN
GETDATE   = ACEALL+150 ;( (.)=DATETRING ) : DATETRING
SETDATE   = ACEALL+153 ;( (.)=DATETRING )
CMDOPEN   = ACEALL+156 ;( (ZP)=EVAME ) : .=FD
CMDCLOSE  = ACEALL+159 ;( .=FD )
CMDSEND   = ACEALL+162 ;( .=FD, (.)=MDTRING )
CMDSTATUS = ACEALL+165 ;( .=FD, (.)=TATUFTR ) : TATUF, .=STATUSODE
GRSCREEN  = ACEALL+168 ;(...)...
GREXIT    = ACEALL+171 ;(...)...
GRFILL    = ACEALL+174 ;(...)...
GRLOAD    = ACEALL+177 ;(...)...
CONKEYAVAIL = ACEALL+180  ;( ) : .=KEYSVAILABLE

ACEPPDDRESS = $7000
ACE1 = $CB
ACE2 = $06
ACE3 = 11

ACEEMULL = $00
ACEEM = $01
ACEEMNTERNAL = $02
ACEEM = $06
ACEEM = $07

ACERRTOPPED = 0
ACERROOANYILES = 1
ACERRILEPEN = 2
ACERRILEOTPEN = 3
ACERRILEOTOUND = 4
ACERREVICEOTRESENT = 5
ACERRILEOTNPUT = 6
ACERRILEOTUTPUT = 7
ACERRISSINGILENAME = 8
ACERRLLEGALEVICE = 9
ACERRRITEROTECT = 26
ACERRILEXISTS = 63
ACERRILEYPEISMATCH = 64
ACERROHANNEL = 70
ACERRISKULL = 72
ACERRNSUFFICIENTEMORY = 128
ACERRPENIRECTORY = 129
ACERRISKNLYPERATION = 131
ACERRULLOINTER = 132
ACERRNVALIDREEARMS = 133
ACERRREEOTWNED = 134
ACERRNVALIDINDOWARMS = 135
ACERRNVALIDONARMS = 136
ACERRNVALIDILEODE = 137
ACERROTMPLEMENTED = 138
ACERRLOADRUNCATED = 139
ACERRERMISSIONENIED = 140
ACERRORAPHICSPACE = 141

STDIN  = 0
STDOUT = 1
STDERR = 2
;===END OF ACE INTERFACE DECLARATIONS===
