;-128/64 KERNEL  80-COLUMN SCREEN DRIVER CODE

;VDC MEMORY LAYOUT: $0000=CHAR,$1000=COLOR,$2000=CHARSET,$3000=ALTCHARSET

VDCOLORDDR = $1000
VDCHARSETDDR = $2000
VDCELECT = $D600
VDCTATUS = $D600
VDCATA = $D601
VDCOWNC = 80

VDCINCR   .BUF 1
VDCINCR   .BUF 1
VDCINOWS   .BUF 1
VDCINOLS   .BUF 1
VDCINTART  .BUF 2
VDCINAVEZ .BUF 2
VDCCROWS   .BYTE 25
VDCCROLS   .BYTE 80
VDCEGUM    .BUF 1

VDCNIT = *
   ;** CHARSET
   JSR VDCILLODE
   JSR VDCOADHARSET
   ;** INIT SCREEN COLORS
   NOP
   ;** MOVE ATTRIBUTES
   LDA #<VDCOLORDDR
   LDY #>VDCOLORDDR
   LDX #$14
   JSR VDCRITE16
   ;** CURSOR HEIGHT
   LDA #8
   LDX #$0B
   JSR VDCRITE
   ;** WINDOW PARAMETERS
   JSR VDCINMAX
   RTS

VDCHUTDOWN = *
   ;** RESTORE CHARSETS
   LDA #<$D000
   LDY #>$D000
   JSR VDCETOMHARSET
   JSR VDCOADHARSET
   LDA #<$D800
   LDY #>$D800
   JSR VDCETOMHARSET
   LDA #<$3000
   LDY #>$3000
   JSR VDCOADPECHARSET
   ;** RESTORE ATTRIBUTES
   LDA #<$800
   LDY #>$800
   LDX #$14
   JSR VDCRITE16
   ;** RESTORE CURSOR HEIGHT
   LDA #7
   LDX #$0B
   JSR VDCRITE
   RTS

VDCETOMHARSET = *
   STA SYSWORK+0
   STY SYSWORK+1
   LDA #<$2000
   LDY #>$2000
   STA SYSWORK+2
   STY SYSWORK+3
   PHP
   SEI
   LDA #BKHARSET
   STA BKELECT
   LDX #8
   LDY #0
-  LDA (SYSWORK+0),Y
   STA (SYSWORK+2),Y
   INY
   BNE -
   INC SYSWORK+1
   INC SYSWORK+3
   DEX
   BNE -
   LDA #BK
   STA BKELECT
   PLP
   RTS

CHSOURCE = SYSWORK+0
CHSOUNT  = SYSWORK+2

VDCOADHARSET = *
   LDA #<VDCHARSETDDR
   LDY #>VDCHARSETDDR
   VDCOADPECHARSET = *
   JSR VDCDDRRITE16
   LDA #<$2000
   LDY #>$2000
   STA CHSOURCE+0
   STY CHSOURCE+1
   LDX #0
   STX CHSOUNT

   CHAROOP = *
   LDA #$1F
   STA VDCEGUM
   STA VDCELECT
   LDY #0
-  LDA (CHSOURCE),Y
-  BIT VDCTATUS
   BPL -
   STA VDCATA
   INY
   CPY #8
   BCC --
   LDA #$00
   JSR VDCAMRITE
   LDX #$1E
   LDA #7
   JSR VDCRITE
   CLC
   LDA CHSOURCE+0
   ADC #8
   STA CHSOURCE+0
   BCC +
   INC CHSOURCE+1
+  INC CHSOUNT
   BNE CHAROOP
   RTS

VDCILLODE = *  ;( )
   LDX #$18
   JSR VDCEAD
   AND #$7F
   JSR VDCRITE
   RTS

VDCOPYODE = *  ;( )
   LDX #$18
   JSR VDCEAD
   ORA #$80
   JSR VDCRITE
   RTS
   
VDCAMRITE = *  ;( .=VALUE )
   LDX #$1F

VDCRITE = *  ;( .=REGISTER, .=VALUE )
   STX VDCEGUM
   STX VDCELECT
-  BIT VDCTATUS
   BPL -
   STA VDCATA
   RTS

VDCDDRRITE16 = *  ;( .=VALUE )
   LDX #$12

VDCRITE16 = *  ;( .=HIEGISTER, .=VALUE )
   STX VDCEGUM
   STX VDCELECT
-  BIT VDCTATUS
   BPL -
   STY VDCATA
   INX
   STX VDCEGUM
   STX VDCELECT
-  BIT VDCTATUS
   BPL -
   STA VDCATA
   RTS

VDCAMEAD = *  ;( ) : .=VALUE
   LDX #$1F

VDCEAD = *  ;( .=REGISTER ) : .=VALUE
   STX VDCEGUM
   STX VDCELECT
-  BIT VDCTATUS
   BPL -
   LDA VDCATA
   RTS

VDCINMAX = *
   LDA #0
   STA VDCINCR
   STA VDCINCR
   STA VDCINTART+0
   STA VDCINTART+1
   LDA VDCCROWS
   LDX VDCCROLS
   STA VDCINOWS
   STX VDCINOLS
   LDA #<2000+2000+16
   LDY #>2000+2000+16
   STA VDCINAVEZ+0
   STY VDCINAVEZ+1
   JSR CONINHANGEALLBACK
   CLC
   RTS

VDCLSOLOR .BUF 1

VDCINCLS = *
   STX VDCILLYTE
   STY VDCLSOLOR
   STA SYSWORK+2
   BIT SYSWORK+2
   BPL +
   JSR VDCINCLSETUP
   JSR VDCOWILL
+  BIT SYSWORK+2
   BVC +
   JSR VDCINCLSETUP
   LDA VDCLSOLOR
   STA VDCILLYTE
   JSR VDCDDOLOR
   JSR VDCOWILL
+  RTS

VDCINCLSETUP = *
   LDA VDCINTART+0
   LDY VDCINTART+1
   STA SYSWORK+0
   STY SYSWORK+1
   LDA VDCINOWS
   STA VDCILLOWS
   RTS

VDCDDOLOR = *
   CLC
   LDA SYSWORK+1
   ADC #>VDCOLORDDR
   STA SYSWORK+1
   RTS

VDCILLYTE .BUF 1
VDCILLOWS .BUF 1
VDCILLOLS .BUF 1

VDCOWILL = * ;( (SW+0)=ADDR++, VDCILLYTE, VDCILLOWS-- )
   LDA VDCINOLS
   STA VDCILLOLS
   LDA VDCILLOWS
   BNE +
   RTS
/  JSR VDCOLILL
   CLC
   LDA SYSWORK+0
   ADC #VDCOWNC
   STA SYSWORK+0
   BCC +
   INC SYSWORK+1
+  DEC VDCILLOWS
   BNE -
   RTS

VDCOLILL = * ;( (SW+0)=ADDR, VDCILLYTE, VDCILLOLS )
   LDA SYSWORK+0
   LDY SYSWORK+1
   JSR VDCDDRRITE16
VDCOLILLOTDDR = *
   LDA VDCILLOLS
   BEQ +
   LDA VDCILLYTE
   JSR VDCAMRITE
   LDX VDCILLOLS
   DEX
   BEQ +
   TXA
   LDX #$1E
   JSR VDCRITE
+  RTS

VDCINSETOWS .BUF 1
VDCINSETOLS .BUF 1

VDCINSET = *
   STA VDCINSETOWS
   CMP #0
   BEQ VDCINSETRR
   STX VDCINSETOLS
   CPX #0
   BEQ VDCINSETRR
   CLC
   ADC SYSWORK+0
   CMP VDCCROWS
   BEQ +
   BCC +

   VDCINSETRR = *
   LDA #ACERRNVALIDINDOWARMS
   STA ERRNO
   SEC
   RTS

+  CLC
   LDA VDCINSETOLS
   ADC SYSWORK+1
   CMP VDCCROLS
   BEQ +
   BCS VDCINSETRR
+  LDA SYSWORK+0
   LDX SYSWORK+1
   STA VDCINCR
   STX VDCINCR
   JSR VDCULT80
   LDA SYSWORK+0
   LDY SYSWORK+1
   STA VDCINTART+0
   STY VDCINTART+1
   LDA VDCINSETOWS
   LDX VDCINSETOLS
   STA VDCINOWS
   STX VDCINOLS
   ;XX VDCINAVEZ
   JSR CONINHANGEALLBACK
   LDA VDCINCR
   LDX VDCINCR
   STA SYSWORK+0
   STX SYSWORK+1
   CLC
   RTS

VDCINSIZE = *
   LDA VDCINTART+0
   LDY VDCINTART+1
   STA SYSWORK+2
   STY SYSWORK+3
   LDA #<VDCOWNC
   LDY #>VDCOWNC
   STA SYSWORK+4
   STY SYSWORK+5
   LDA VDCINCR
   LDX VDCINCR
   STA SYSWORK+0
   STX SYSWORK+1
   LDA VDCINOWS
   LDX VDCINOLS
   CLC
   RTS

VDCUTHICH .BUF 1
VDCUTOLOR .BUF 1
VDCUTEN   .BUF 1

VDCINPUT = *
   STA VDCUTHICH
   STY VDCILLYTE
   STX VDCUTEN
   BIT VDCUTHICH
   BPL VDCINPUTOLOR
   LDA SYSWORK+0
   LDY SYSWORK+1
   JSR VDCDDRRITE16
   LDY #0
   CPY VDCUTEN
   BEQ +
   LDA #$1F
   STA VDCEGUM
   STA VDCELECT
-  LDA (SYSWORK+2),Y 
-  BIT VDCTATUS
   BPL -
   STA VDCATA
   INY
   CPY VDCUTEN
   BCC --
+  SEC
   LDA SYSWORK+5
   SBC VDCUTEN
   BEQ VDCINPUTOLOR
   TAY
   LDA SYSWORK+4
   JSR VDCAMRITE
   DEY
   BEQ VDCINPUTOLOR
   TYA
   LDX #$1E
   JSR VDCRITE

   VDCINPUTOLOR = *
   BIT VDCUTHICH
   BVS +
   RTS
+  LDA SYSWORK+1
   CLC
   ADC #>VDCOLORDDR
   TAY
   LDA SYSWORK+0
   JSR VDCDDRRITE16
   LDA SYSWORK+5
   STA VDCILLOLS
   JSR VDCOLILLOTDDR
   RTS

VDCINCOLOR = *
   PHP
   SEI
   BIT VDCSCTIVE
   BMI VDCINCOLORSCTIVE
   CMP #128
   BCC +
   TXA
   LDX #$1A
   JSR VDCRITE
+  AND #64
   BEQ +
   TYA
   NOP
+  LDX #$1A
   JSR VDCEAD
   AND #$0F
   TAX
   TAY
   PLP
   RTS

   VDCINCOLORSCTIVE = *
   CMP #128
   BCC +
   STX VDCSOLOR
+  LDA VDCSOLOR
   AND #$0F
   TAX
   TAY
   PLP
   RTS

VDCINPOS = *
   JSR VDCULT80
   CLC
   LDA SYSWORK+0
   ADC VDCINTART+0
   STA SYSWORK+0
   LDA SYSWORK+1
   ADC VDCINTART+1
   STA SYSWORK+1
   RTS

VDCULT80 = *  ;( .=ROW:0-255, .=COL ) : (SW+0)=ROW*80+COL, .:UNCH
   STA SYSWORK+0
   LDY #0
   STY SYSWORK+1
   ASL
   ROL SYSWORK+1
   ASL
   ROL SYSWORK+1
   ADC SYSWORK+0
   BCC +
   INC SYSWORK+1
+  ASL
   ROL SYSWORK+1
   ASL
   ROL SYSWORK+1
   ASL
   ROL SYSWORK+1
   ASL
   ROL SYSWORK+1
   STX SYSWORK+0
   CLC
   ADC SYSWORK+0
   BCC +
   INC SYSWORK+1
+  STA SYSWORK+0
   RTS

VDCURSORAVE  .BUF 1
VDCURSOROLOR .BUF 1

VDCINCURSOR = *
   CMP #0
   BEQ VDCURSORFF
   STY VDCURSOROLOR
   LDA SYSWORK+0
   LDY SYSWORK+1
   LDX #$0E
   JSR VDCRITE16
   LDX #$0A
   JSR VDCEAD
   AND #$1F
   ORA #$60
   JSR VDCRITE
   JSR VDCETOLORDDR
   JSR VDCAMEAD
   STA VDCURSORAVE
   JSR VDCETOLORDDR
   LDA VDCURSORAVE
   AND #$F0
   ORA VDCURSOROLOR
   JSR VDCAMRITE
   RTS

VDCURSORFF = *
   LDX #$0E
   JSR VDCRITE16
   LDX #$0A
   JSR VDCEAD
   AND #$1F
   ORA #$20
   JSR VDCRITE
   JSR VDCETOLORDDR
   LDA VDCURSORAVE
   JSR VDCAMRITE
   RTS

VDCETOLORDDR = *  ;( (SW+0)=ADDR )
   CLC
   LDA SYSWORK+1
   ADC #>VDCOLORDDR
   TAY
   LDA SYSWORK+0
   JMP VDCDDRRITE16

VDCRQURSOR = *
   ;** DO NOTHING
   RTS

VDCCROLLEST   = SYSWORK+0
VDCCROLLOURCE = SYSWORK+2
VDCCROLLOWS   .BUF 1
VDCCROLLXTRA  .BUF 1

VDCINSCROLL = *
   STA SYSWORK+5
   STY VDCLSOLOR
   STX VDCCROLLXTRA
   CPX #0
   BNE +
-  RTS
+  LDA SYSWORK+5
   AND #%1000
   BEQ -
   CPX VDCINOWS
   BCC +
   LDX SYSWORK+4
   LDA SYSWORK+5
   LDY VDCLSOLOR
   JSR VDCINCLS
   RTS
+  BIT SYSWORK+5
   BPL +
   JSR VDCCROLLPETUP
   JSR VDCOWCROLLP
   LDA SYSWORK+4
   JSR VDCOCROLLXTRA
+  BIT SYSWORK+5
   BVC +
   JSR VDCCROLLPETUP
   JSR VDCCROLLDDOLOR
   JSR VDCOWCROLLP
   LDA VDCLSOLOR
   JSR VDCOCROLLXTRA
+  RTS

VDCCROLLPETUP = *
   LDA VDCCROLLXTRA
   LDX #0
   JSR VDCINPOS
   LDA SYSWORK+0
   LDY SYSWORK+1
   STA VDCCROLLOURCE+0
   STY VDCCROLLOURCE+1
   LDA VDCINTART+0
   LDY VDCINTART+1
   STA VDCCROLLEST+0
   STY VDCCROLLEST+1
   SEC
   LDA VDCINOWS
   SBC VDCCROLLXTRA
   STA VDCCROLLOWS
   RTS

VDCCROLLDDOLOR = *
   CLC
   LDA SYSWORK+1
   ADC #>VDCOLORDDR
   STA SYSWORK+1
   LDA SYSWORK+3
   ADC #>VDCOLORDDR
   STA SYSWORK+3
   RTS

VDCOCROLLXTRA = *  ;( .=FILLYTE, (SW+0)=ADDR )
   STA VDCILLYTE
   LDA VDCCROLLXTRA
   STA VDCILLOWS
   LDA VDCINOLS
   STA VDCILLOLS
   JSR VDCOWILL
   RTS

VDCOWCROLLP = * ;( VDCCROLLOURCE++, VDCCROLLEST++, VDCCROLLOWS-- )
   LDA VDCCROLLOWS
   BNE +
   RTS
+  JSR VDCOPYODE
-  JSR VDCOLCROLL
   CLC
   LDA VDCCROLLOURCE+0
   ADC #VDCOWNC
   STA VDCCROLLOURCE+0
   BCC +
   INC VDCCROLLOURCE+1
+  CLC
   LDA VDCCROLLEST+0
   ADC #VDCOWNC
   STA VDCCROLLEST+0
   BCC +
   INC VDCCROLLEST+1
+  DEC VDCCROLLOWS
   BNE -
   JSR VDCILLODE
   RTS

VDCOLCROLL = * ;( VDCCROLLOURCE, VDCCROLLEST, VDCINOLS )
   LDA VDCCROLLEST+0
   LDY VDCCROLLEST+1
   JSR VDCDDRRITE16
   LDA VDCCROLLOURCE+0
   LDY VDCCROLLOURCE+1
   LDX #$20
   JSR VDCRITE16
   LDA VDCINOLS
   LDX #$1E
   JSR VDCRITE
   RTS

;*** INTERRUPT SCREEN-SAVER CODE: **POTENTIAL VDC-ACCESS CONFLICTS**

VDCSOLOR  .BUF 1
VDCSODE   .BUF 1
VDCSCTIVE .BYTE $00

VDCCREENAVE = *
-  BIT VDCTATUS
   BPL -
   LDA VDCEGUM
   PHA
   LDX #$19
   JSR VDCEAD
   STA VDCSODE
   LDX #$1A
   JSR VDCEAD
   STA VDCSOLOR
   LDA #$FF
   STA VDCSCTIVE
   LDX #$19
   LDA VDCSODE
   AND #%10111111
   JSR VDCRITE
   LDX #$1A
   LDA #$00
   JSR VDCRITE
   PLA
   STA VDCEGUM
   STA VDCELECT
-  BIT VDCTATUS
   BPL -
   RTS

VDCCREENNSAVE = *
-  BIT VDCTATUS
   BPL -
   LDA VDCEGUM
   PHA
   LDX #$19
   LDA VDCSODE
   JSR VDCRITE
   LDX #$1A
   LDA VDCSOLOR
   JSR VDCRITE
   LDA #$00
   STA VDCSCTIVE
   PLA
   STA VDCEGUM
   STA VDCELECT
-  BIT VDCTATUS
   BPL -
   RTS

;=== HIRES STUFF STUFF ===

;VDC REGISTER VALUES COURTESY OF RED OWEN OF OMMODORE

;VDC MEMORY: 00000-21359=EVEN FRAME, 21360-42719=ODD FRAME

VDCVENRAME  = 0
VDCDDRAME   = 21360
VDCRODE     .BUF 1  ;$00=LORES, $FF=HIRES
VDCROLOR    .BUF 1

ACERCREEN = *  ; ( .=GRYPE, .=BORDEROLOR, .=GGOLOR )
   PHA           ;               : .=COLS8, (SW+0)=ROWS, .=XSPECT
   STY VDCROLOR
   TYA
   LDX #4
-  ASL
   LSR VDCROLOR
   DEX
   BNE -
   ORA VDCROLOR
   STA VDCROLOR
   LDX #26
   JSR VDCRITE
   PLA
   CMP #1
   BEQ +
   LDA CONFIGUF+$AA
   CMP #64
   BCC +
   LDA CONFIGUF+$C7
   BNE +
   JMP ACERCREENIRES
+  LDA #$00      
   STA VDCRODE
   ;XX RE-SELECT 25 ROWS
   LDX #25
   JSR VDCEAD
   AND #%00001111
   ORA #%10000000
   JSR VDCRITE
   LDA #$00
   JSR ACERILL
   LDA #<200
   LDY #>200
   STA SYSWORK+0
   STY SYSWORK+1
   LDA #80
   LDX #2
   CLC
   RTS

   ACERCREENIRES = *
   LDA #$FF
   STA VDCRODE
   LDY #0
-  LDX INITEGS,Y
   LDA INITALS,Y
   CPX #25
   BNE +
   JSR VDCEAD
   AND #$0F
   ORA INITALS,Y
+  JSR VDCRITE
   INY
   CPY #INITALS-INITEGS
   BCC -
   LDA #$00
   JSR ACERILL
   LDA #<491
   LDY #>491
   STA SYSWORK+0
   STY SYSWORK+1
   LDA #80
   LDX #1
   CLC
   RTS

INITEGS = *
   .BYTE 000,001,002,004,005,006,007,008,009,024,025,027,028,020,021
   .BYTE 012,013,026,012,013
INITALS = *            
   .BYTE $7E,$50,$66,$4C,006,$4C,$47,003,006,000,$80,000,016,166,224
   .BYTE 000,000,224,0,0    ;LAST TWO = >EVENRAME,<EVENRAME

ACERXIT = *  ;( )
   JSR $E179
   JSR VDCNIT
   LDA #$E0
   LDX #$20
   LDY #$0F
   JSR VDCINCLS
   JSR CONINNIT
   CLC
   RTS

ACERILL = *  ;( .=FILLALUE )
   PHA
   LDA #>VDCVENRAME
   LDY #<VDCVENRAME
   JSR VDCDDRRITE16
   LDX #31
   PLA
   JSR VDCRITE
   LDY #161
   BIT VDCRODE
   BMI +
   LDY #63
+  NOP
-  LDX #30
   LDA #$00
   JSR VDCRITE
   DEY
   BNE -
   BIT VDCRODE
   BPL +
   LDA #<VDCDDRAME+19600
   LDY #>VDCDDRAME+19600
   JSR VDCDDRRITE16
   LDA #$00
   JSR VDCAMRITE
   LDA #79
   LDX #$1E
   JSR VDCRITE
+  CLC
   RTS

VDCMRAME .BUF 1
VDCMOWS  .BUF 1
VDCMOLS  .BUF 1

ACEROAD = *  ;( .=, (SW+0)=, .=COLS, .=1, (SW+2)=PTR )
   STY VDCMOWS
   STX VDCMOLS
   TAX
   BIT VDCRODE
   BMI +
   LDA SYSWORK+0
   LDY SYSWORK+1
   JSR VDCULT80
   JMP ++
+  LSR SYSWORK+1
   LDA SYSWORK+0
   STA VDCMRAME
   ROR
   JSR VDCULT80
   LDA VDCMRAME
   AND #$01
   BEQ +
   CLC
   LDA SYSWORK+0
   ADC #<VDCDDRAME
   STA SYSWORK+0
   LDA SYSWORK+1
   ADC #>VDCDDRAME
   STA SYSWORK+1
   ;XX IMPLEMENT FOR MULTIPLE LINES?
+  LDA SYSWORK+0
   LDY SYSWORK+1
   JSR VDCDDRRITE16
   LDY #0
   CPY VDCMOLS
   BEQ +
   LDA #$1F
   STA VDCEGUM
   STA VDCELECT
-  LDA (SYSWORK+2),Y 
-  BIT VDCTATUS
   BPL -
   STA VDCATA
   INY
   CPY VDCMOLS
   BCC --
+  CLC
   RTS

;THE END + BLANK LINE

