;-128/64 KERNEL  40-COLUMN SCREEN DRIVER CODE

VICHARDDR = $0400
VICOLORFF = $D400
VICOWNC = 40
VIC = $D000

VICINCR   .BUF 1
VICINCR   .BUF 1
VICINOWS   .BUF 1
VICINOLS   .BUF 1
VICINTART  .BUF 2
VICINAVEZ .BUF 2

VICNIT = *
   LDA VIC+$11
   AND #%00011111
   STA VIC+$11
   LDA #$18
   STA VIC+$18
   LDA $DD00
   AND #%11111100
   ORA #%00000011
   STA $DD00
   ;** WINDOW PARAMETERS
   JSR VICINMAX
   RTS

VICHUTDOWN = *
   RTS

VICINMAX = *
   LDA #0
   STA VICINCR
   STA VICINCR
   LDA #<VICHARDDR
   LDY #>VICHARDDR
   STA VICINTART+0
   STY VICINTART+1
   LDA #25
   LDX #40
   STA VICINOWS
   STX VICINOLS
   LDA #<1000+1000+16
   LDY #>1000+1000+16
   STA VICINAVEZ+0
   STY VICINAVEZ+1
   JSR CONINHANGEALLBACK
   CLC
   RTS

RGBI2VICAB .BYTE 0,11,6,14,5,13,12,3,2,10,8,4,9,7,15,1

RGBI2VIC = *
   AND #$0F
   TAX
   LDA RGBI2VICAB,X
   RTS

VIC2RGBIAB .BYTE 0,15,8,7,11,4,2,13,10,12,9,1,6,5,3,14

VIC2RGBI = *
   AND #$0F
   TAX
   LDA VIC2RGBIAB,X
   RTS

VICLSOLOR .BUF 1

VICINCLS = *
   STX VICILLYTE
   STY VICLSOLOR
   STA SYSWORK+2
   BIT SYSWORK+2
   BPL +
   JSR VICINCLSETUP
   JSR VICOWILL
+  BIT SYSWORK+2
   BVC +
   JSR VICINCLSETUP
   LDA VICLSOLOR
   JSR RGBI2VIC
   STA VICILLYTE
   JSR VICDDOLOR
   JSR VICOWILL
+  RTS

VICINCLSETUP = *
   LDA VICINTART+0
   LDY VICINTART+1
   STA SYSWORK+0
   STY SYSWORK+1
   LDA VICINOWS
   STA VICILLOWS
   RTS

VICDDOLOR = *
   CLC
   LDA SYSWORK+1
   ADC #>VICOLORFF
   STA SYSWORK+1
   RTS

VICILLYTE .BUF 1
VICILLOWS .BUF 1
VICILLOLS .BUF 1

VICOWILL = * ;( (SW+0)=ADDR++, VICILLYTE, VICILLOWS-- )
   LDA VICINOLS
   STA VICILLOLS
   LDA VICILLOWS
   BNE +
   RTS
/  JSR VICOLILL
   CLC
   LDA SYSWORK+0
   ADC #VICOWNC
   STA SYSWORK+0
   BCC +
   INC SYSWORK+1
+  DEC VICILLOWS
   BNE -
   RTS

VICOLILL = * ;( (SW+0)=ADDR, VICILLYTE, VICILLOLS )
   LDY VICILLOLS
   BEQ +
   DEY
   LDA VICILLYTE
-  STA (SYSWORK),Y
   DEY
   BPL -
+  RTS

VICINSETOWS .BUF 1
VICINSETOLS .BUF 1

VICINSET = *  ;%%%
   STA VICINSETOWS
   CMP #0
   BEQ VICINSETRR
   STX VICINSETOLS
   CPX #0
   BEQ VICINSETRR
   CLC
   ADC SYSWORK+0
   CMP #25
   BEQ +
   BCC +

   VICINSETRR = *
   LDA #ACERRNVALIDINDOWARMS
   STA ERRNO
   SEC
   RTS

+  CLC
   LDA VICINSETOLS
   ADC SYSWORK+1
   CMP #40
   BEQ +
   BCS VICINSETRR
+  LDA SYSWORK+0
   LDX SYSWORK+1
   STA VICINCR
   STX VICINCR
   JSR VICULT40
   LDA SYSWORK+0
   STA VICINTART+0
   CLC
   LDA SYSWORK+1
   ADC #>VICHARDDR
   STA VICINTART+1
   LDA VICINSETOWS
   LDX VICINSETOLS
   STA VICINOWS
   STX VICINOLS
   ;XX VICINAVEZ
   JSR CONINHANGEALLBACK
   LDA VICINCR
   LDX VICINCR
   STA SYSWORK+0
   STX SYSWORK+1
   CLC
   RTS

VICINSIZE = *
   LDA VICINTART+0
   LDY VICINTART+1
   STA SYSWORK+2
   STY SYSWORK+3
   LDA #<VICOWNC
   LDY #>VICOWNC
   STA SYSWORK+4
   STY SYSWORK+5
   LDA VICINCR
   LDX VICINCR
   STA SYSWORK+0
   STX SYSWORK+1
   LDA VICINOWS
   LDX VICINOLS
   CLC
   RTS

VICUTHICH .BUF 1
VICUTEN   .BUF 1

VICINPUT = *
   STA VICUTHICH
   STY VICILLYTE
   STX VICUTEN
   BIT VICUTHICH
   BPL VICINPUTOLOR
   LDY #0
   CPY VICUTEN
   BEQ +
-  LDA (SYSWORK+2),Y
   STA (SYSWORK+0),Y
   INY
   CPY VICUTEN
   BCC -
+  CPY SYSWORK+5
   BEQ VICINPUTOLOR
   LDA SYSWORK+4
-  STA (SYSWORK+0),Y
   INY
   CPY SYSWORK+5
   BCC -

   VICINPUTOLOR = *
   BIT VICUTHICH
   BVS +
   RTS
+  CLC
   LDA SYSWORK+1
   ADC #>VICOLORFF
   STA SYSWORK+1
   LDA VICILLYTE
   JSR RGBI2VIC
   LDY SYSWORK+5
   DEY
   BMI +
-  STA (SYSWORK),Y
   DEY
   BPL -
+  SEC
   LDA SYSWORK+1
   SBC #>VICOLORFF
   STA SYSWORK+1
   RTS

VICINCOLOR = *
   PHP
   SEI
   CMP #128
   BCC +
   PHA
   TXA
   JSR RGBI2VIC
   STA VIC+$21
   PLA
+  AND #64
   BEQ VICINCOLORXIT
   TYA
   JSR RGBI2VIC
   BIT VICSCTIVE
   BMI +
   STA VIC+$20
   JMP VICINCOLORXIT
+  STA VICSOLOR

   VICINCOLORXIT = *
   BIT VICSCTIVE
   BMI +
   LDA VIC+$20
   JMP ++
+  LDA VICSOLOR
+  JSR VIC2RGBI
   TAY
   LDA VIC+$21
   JSR VIC2RGBI
   TAX
   PLP
   RTS

VICINPOS = *
   JSR VICULT40
   CLC
   LDA SYSWORK+0
   ADC VICINTART+0
   STA SYSWORK+0
   LDA SYSWORK+1
   ADC VICINTART+1
   STA SYSWORK+1
   RTS

VICULT40 = *  ;( .=ROW:0-24, .=COL ) : (SW+0)=ROW*40+COL, .:UNCH
   STA SYSWORK+0
   LDY #0
   STY SYSWORK+1
   ASL
   ASL
   ADC SYSWORK+0
   ASL
   ROL SYSWORK+1
   ASL
   ROL SYSWORK+1
   ASL
   ROL SYSWORK+1
   STX SYSWORK+0
   CLC
   ADC SYSWORK+0
   BCC +
   INC SYSWORK+1
+  STA SYSWORK+0
   RTS

VICURSORHAR  .BUF 1
VICURSOROLOR .BUF 1
VICURSORLASH .BYTE $00  ;$00=INACTIVE, $FF=ACTIVE
VICURSOROUNTDOWN .BUF 1
VICURSORDDR  .BUF 2

VICINCURSOR = *
   CMP #0
   BEQ VICURSORFF
   TYA
   JSR RGBI2VIC
   STA VICURSOROLOR
   LDA SYSWORK+0
   LDY SYSWORK+1
   STA VICURSORDDR+0
   STY VICURSORDDR+1
   LDY #0
   LDA (SYSWORK+0),Y
   STA VICURSORHAR
   JSR VICETOLORDDR
   LDY #0
   LDA (SYSWORK+0),Y
   TAX
   LDA VICURSOROLOR
   STA (SYSWORK+0),Y
   STX VICURSOROLOR
   JSR VICNSETOLORDDR
   LDA #1
   STA VICURSOROUNTDOWN
   JSR VICRQURSORNTER
   LDA #$FF
   STA VICURSORLASH
   RTS

VICURSORFF = *
   LDA #$00
   STA VICURSORLASH
   LDY #0
   LDA VICURSORHAR
   STA (SYSWORK+0),Y
   JSR VICETOLORDDR
   LDA VICURSOROLOR
   STA (SYSWORK+0),Y
   JSR VICNSETOLORDDR
   RTS

VICRQORK = $A0

VICRQURSOR = *
   BIT VICURSORLASH
   BMI VICRQURSORNTER
-  RTS
   VICRQURSORNTER = *
   DEC VICURSOROUNTDOWN
   BNE -
   LDA #20
   STA VICURSOROUNTDOWN
   LDA VICURSORDDR+0
   LDY VICURSORDDR+1
   STA VICRQORK+0
   STY VICRQORK+1
   LDY #0
   LDA (VICRQORK),Y
   PHA
   SEC
   SBC #32
   AND #%01000000
   BNE +
   PLA
   SEC
   SBC #64
   JMP ++
+  PLA
   CLC
   ADC #64
+  STA (VICRQORK),Y
   RTS

VICETOLORDDR = *  ;( (SW+0)=ADDR ) : (SW+0)=COLORDDR
   CLC
   LDA SYSWORK+1
   ADC #>VICOLORFF
   STA SYSWORK+1
   RTS

VICNSETOLORDDR = *  ;( (SW+0)=COLORDDR ) : (SW+0)=ADDR
   SEC
   LDA SYSWORK+1
   SBC #>VICOLORFF
   STA SYSWORK+1
   RTS

VICCROLLEST   = SYSWORK+0
VICCROLLOURCE = SYSWORK+2
VICCROLLOWS   .BUF 1
VICCROLLXTRA  .BUF 1

VICINSCROLL = *
   STA SYSWORK+5
   STY VICLSOLOR
   STX VICCROLLXTRA
   CPX #0
   BNE +
-  RTS
+  LDA SYSWORK+5
   AND #%1000
   BEQ -
   CPX VICINOWS
   BCC +
   LDX SYSWORK+4
   LDA SYSWORK+5
   LDY VICLSOLOR
   JSR VICINCLS
   RTS
+  BIT SYSWORK+5
   BPL +
   JSR VICCROLLPETUP
   JSR VICOWCROLLP
   LDA SYSWORK+4
   JSR VICOCROLLXTRA
+  BIT SYSWORK+5
   BVC +
   JSR VICCROLLPETUP
   JSR VICCROLLDDOLOR
   JSR VICOWCROLLP
   LDA VICLSOLOR
   JSR VICOCROLLXTRA
+  RTS

VICCROLLPETUP = *
   LDA VICCROLLXTRA
   LDX #0
   JSR VICINPOS
   LDA SYSWORK+0
   LDY SYSWORK+1
   STA VICCROLLOURCE+0
   STY VICCROLLOURCE+1
   LDA VICINTART+0
   LDY VICINTART+1
   STA VICCROLLEST+0
   STY VICCROLLEST+1
   SEC
   LDA VICINOWS
   SBC VICCROLLXTRA
   STA VICCROLLOWS
   RTS

VICCROLLDDOLOR = *
   CLC
   LDA SYSWORK+1
   ADC #>VICOLORFF
   STA SYSWORK+1
   LDA SYSWORK+3
   ADC #>VICOLORFF
   STA SYSWORK+3
   RTS

VICOCROLLXTRA = *  ;( .=FILLYTE, (SW+0)=ADDR )
   STA VICILLYTE
   LDA VICCROLLXTRA
   STA VICILLOWS
   LDA VICINOLS
   STA VICILLOLS
   JSR VICOWILL
   RTS

VICOWCROLLP = * ;( VICCROLLOURCE++, VICCROLLEST++, VICCROLLOWS-- )
   LDA VICCROLLOWS
   BNE +
   RTS
+  NOP
-  JSR VICOLCROLL
   CLC
   LDA VICCROLLOURCE+0
   ADC #VICOWNC
   STA VICCROLLOURCE+0
   BCC +
   INC VICCROLLOURCE+1
+  CLC
   LDA VICCROLLEST+0
   ADC #VICOWNC
   STA VICCROLLEST+0
   BCC +
   INC VICCROLLEST+1
+  DEC VICCROLLOWS
   BNE -
   RTS

VICOLCROLL = * ;( VICCROLLOURCE, VICCROLLEST, VICINOLS )
   LDY VICINOLS
   DEY
-  LDA (VICCROLLOURCE),Y
   STA (VICCROLLEST),Y
   DEY
   BPL -
   RTS

;*** INTERRUPT SCREEN-SAVE STUFF

VICSOLOR  .BUF 1
VICSOWS   .BUF 1
VICSCTIVE .BYTE $00

VICCREENAVE = *
   LDA VIC+$11
   STA VICSOWS
   LDA VIC+$20
   STA VICSOLOR
   LDA #$FF
   STA VICSCTIVE
   LDA #$00
   STA VIC+$11
   LDA #$00
   STA VIC+$20
   RTS

VICCREENNSAVE = *
   LDA VICSOWS
   AND #%01111111
   STA VIC+$11
   LDA VICSOLOR
   STA VIC+$20
   LDA #$00
   STA VICSCTIVE
   RTS

;THE END + BLANK LINE

