;-64 KERNEL  BITMAPPED 80-COLUMN SCREEN DRIVER CODE

;VIC MEMORY LAYOUT: $E000=BITMAP, $DC00=COLOR, $D800=CHARSET4BIT

VDCHARDDR = $E000
VDCOLORDDR = $DC00
CHARSET4BIT  = $D800
VDCOWNC = 80
VDCOWHYSNC = 320
VDCOLORNC = 40

VDCINCR   .BUF 1
VDCINCR   .BUF 1
VDCINOWS   .BUF 1
VDCINOLS   .BUF 1
VDCINTART  .BUF 2
VDCINAVEZ .BUF 2
VDCCROWS   .BYTE 25
VDCCROLS   .BYTE 80
VDCACKOLOR .BUF 1
VDCHAR      .BUF 8

VDCTARTUP = *
   LDA #ACEEMULL
   STA VDCCROLLEUORK+3
   LDA CONFIGUF+$C0
   AND #$20
   BEQ +
   LDA #$FC
   STA ALLOCROC
   LDA #>7680
   LDX #ACEEM
   LDY #ACEEM
   JSR KERNAGELLOC
   BCS +
   LDX #3
-  LDA MP,X
   STA VDCCROLLEUORK,X
   DEX
   BPL -
+  RTS
   
VDCNIT = *
   LDA VIC+$11
   AND #%01111111
   ORA #%00100000
   STA VIC+$11
   LDA VIC+$18
   AND #$0F
   ORA #$70
   STA VIC+$18
   LDA $DD00
   AND #%11111100
   STA $DD00
   JSR VDCINMAX
   LDA CONFIGUF+$D7
   JSR RGBI2VIC
   ASL
   ASL
   ASL
   ASL
   STA VDCACKOLOR
   RTS

VDCHUTDOWN = *
   LDA VIC+$11
   AND #%00011111
   STA VIC+$11
   AND #$18
   STA VIC+$18
   LDA $DD00
   AND #%11111100
   ORA #%00000011
   STA $DD00
   RTS

VICBITORK .BUF 1

RGBI2VICBIT = *  ;.=COLOR, .=MODATTERN
   PHA
   AND #$0F
   TAX
   LDA RGBI2VICAB,X
   ASL
   ASL
   ASL
   ASL
   STA VICBITORK
   TYA
   AND #$20
   BEQ +
   PLA
   LSR
   LSR
   LSR
   LSR
   TAX
   LDA RGBI2VICAB,X
   JMP ++
+  PLA
   LDA VDCACKOLOR
+  ORA VICBITORK
   RTS

VICBIT2RGBI = *
   BRK

VDCINMAX = *
   LDA #0
   STA VDCINTART+0
   STA VDCINTART+1
   STA VDCINCR
   STA VDCINCR
   LDA VDCCROWS
   LDX VDCCROLS
   STA VDCINOWS
   STX VDCINOLS
   LDA #<8000+1000+16
   LDY #>8000+1000+16
   STA VDCINAVEZ+0
   STY VDCINAVEZ+1
   JSR CONINHANGEALLBACK
   CLC
   RTS

VDCLSOLOR .BUF 1

VDCINCLS = *
   LDX #$00         ;FORCED FILL PATTERN, FOR NOW
   VDCINCLSATTERN = *
   STX VDCILLYTE
   STA SYSWORK+2
   TYA
   LDY SYSWORK+2
   JSR RGBI2VICBIT
   STA VDCLSOLOR
   BIT SYSWORK+2
   BPL +
   JSR VDCINCLSETUP
   JSR VDCDDHAR
   JSR VDCOWILL
+  BIT SYSWORK+2
   BVC +
   LDA VDCLSOLOR
   STA VDCILLYTE
   JSR VDCINCLSETUP
   JSR VDCDDOLOR
   LDA #BKAM0
   STA BKELECT
   JSR VDCOWILLOLOR
   LDA #BK
   STA BKELECT
+  RTS

VDCINCLSETUP = *
   LDA VDCINTART+0
   LDY VDCINTART+1
   STA SYSWORK+0
   STY SYSWORK+1
   LDA VDCINOWS
   STA VDCILLOWS
   RTS

VDCDDHAR = *
   LDA SYSWORK+1
   ASL SYSWORK+0
   ROL
   ASL SYSWORK+0
   ROL
   CLC
   ADC #>VDCHARDDR
   STA SYSWORK+1
   RTS

VDCDDOLOR = *
   LDA SYSWORK+1
   LSR
   ROR SYSWORK+0
   CLC
   ADC #>VDCOLORDDR
   STA SYSWORK+1
   RTS

VDCILLYTE .BUF 1
VDCILLOWS .BUF 1
VDCILLOLS .BUF 1

VDCOWILL = * ;( (SW+0)=ADDR++, VDCILLYTE, VDCILLOWS-- )
   LDA VDCINOLS
   STA VDCILLOLS
   LDA VDCILLOWS
   BNE +
   RTS
/  JSR VDCOLILL
   CLC
   LDA SYSWORK+0
   ADC #<VDCOWHYSNC
   STA SYSWORK+0
   LDA SYSWORK+1
   ADC #>VDCOWHYSNC
   STA SYSWORK+1
   DEC VDCILLOWS
   BNE -
   RTS

VDCOWILLOLOR = * ;( (SW+0)=ADDR++, VDCILLYTE, VDCILLOWS-- )
   LDA VDCINOLS
   STA VDCILLOLS
   LDA VDCILLOWS
   BNE +
   RTS
/  JSR VDCOLILL
   CLC
   LDA SYSWORK+0
   ADC #<VDCOLORNC
   STA SYSWORK+0
   LDA SYSWORK+1
   ADC #>VDCOLORNC
   STA SYSWORK+1
   DEC VDCILLOWS
   BNE -
   RTS

VDCOLILL = * ;( (SW+0)=ADDR, VDCILLYTE, VDCILLOLS )
VDCOLILLOTDDR = *
   LDY VDCILLOLS
   BEQ ++
   LDA SYSWORK+1
   CMP #>VDCHARDDR
   BCS VDCOLILLITMAP
   LDA VDCILLOLS
   CLC
   ADC #1 ;ROUND UP
   LSR
   TAY
   BEQ ++

   VDCOLF256 = *
   LDA VDCILLYTE
   DEY
   BEQ +
-  STA (SYSWORK+0),Y
   DEY
   BNE -
+  STA (SYSWORK+0),Y
+  RTS

   VDCOLILLITMAP = *
   LDA VDCILLOLS
   AND #%11111110
   ASL
   ASL
   TAY
   BCC VDCOLF256
   INC SYSWORK+1
   JSR VDCOLF256
   DEC SYSWORK+1
   LDY #0
   JMP VDCOLF256

VDCINSETOWS .BUF 1
VDCINSETOLS .BUF 1

VDCINSET = *
   CLC
   RTS

VDCINSIZE = *
   LDA VDCINTART+0
   LDY VDCINTART+1
   STA SYSWORK+2
   STY SYSWORK+3
   LDA #<VDCOWNC
   LDY #>VDCOWNC
   STA SYSWORK+4
   STY SYSWORK+5
   LDA VDCINCR
   LDX VDCINCR
   STA SYSWORK+0
   STX SYSWORK+1
   LDA VDCINOWS
   LDX VDCINOLS
   CLC
   RTS

VDCUTHICH .BUF 1
VDCUTOLOR .BUF 1
VDCUTEN   .BUF 1
VDCDDR     .BUF 2
VDCOS      .BUF 1

VDCINPUT = *
   STA VDCUTHICH
   STX VDCUTEN
   TYA
   LDY VDCUTHICH
   JSR RGBI2VICBIT
   STA VDCILLYTE
   LDA SYSWORK+0
   LDY SYSWORK+1
   STA VDCDDR+0
   STY VDCDDR+1
   JSR VDCDDHAR
   LDA #BKAM0
   STA BKELECT
   BIT VDCUTHICH
   BMI +
   JMP VDCINPUTOLOR
+  LDY #0
   STY VDCOS

   VDCINPUTEXT = *
   LDY VDCOS
   CPY VDCUTEN
   BCS +
   LDA (SYSWORK+2),Y 
   JMP +++
+  CPY SYSWORK+5
   BCC +
   JMP VDCINPUTOLOR
+  LDA SYSWORK+4

   ;** LOCATE CHARACTER
+  LDY #0
   STY SYSWORK+7
   ASL
   ROL SYSWORK+7
   ASL
   ROL SYSWORK+7
   CLC
   ADC #<CHARSET4BIT
   STA SYSWORK+6
   LDA SYSWORK+7
   ADC #>CHARSET4BIT
   STA SYSWORK+7

   VDCINPUTHS = *
   LDA SYSWORK+0
   AND #$07
   BNE VDCINPUTHS
   LDY #0
   LDX #0
-  LDA (SYSWORK+6),Y
   AND #$F0
   STA VDCHAR,X
   INX
   LDA (SYSWORK+6),Y
   ASL
   ASL
   ASL
   ASL
   STA VDCHAR,X
   INX
   INY
   CPY #4
   BCC -
   LDY #7
-  LDA (SYSWORK+0),Y
   AND #$0F
   ORA VDCHAR,Y
   STA (SYSWORK+0),Y
   DEY
   BPL -
   JMP VDCINPUTONT

   VDCINPUTHS = *
   LDA SYSWORK+0
   AND #%11111000
   STA SYSWORK+0
   LDY #0
   LDX #0
-  LDA (SYSWORK+6),Y
   LSR
   LSR
   LSR
   LSR
   STA VDCHAR,X
   INX
   LDA (SYSWORK+6),Y
   AND #$0F
   STA VDCHAR,X
   INX
   INY
   CPY #4
   BCC -
   LDY #7
-  LDA (SYSWORK+0),Y
   AND #$F0
   ORA VDCHAR,Y
   STA (SYSWORK+0),Y
   DEY
   BPL -
   LDA SYSWORK+0
   ORA #%00000100
   STA SYSWORK+0

   VDCINPUTONT = *
   INC VDCOS
   CLC
   LDA SYSWORK+0
   ADC #4
   STA SYSWORK+0
   BCC +
   INC SYSWORK+1
+  JMP VDCINPUTEXT

   VDCINPUTOLOR = *
   BIT VDCUTHICH
   BVC VDCINPUTXIT
   LDA VDCDDR+0
   LDY VDCDDR+1
   STA SYSWORK+0
   STY SYSWORK+1
   JSR VDCDDOLOR
   LDA SYSWORK+5
   STA VDCILLOLS
   JSR VDCOLILL

   VDCINPUTXIT = *
   LDA #BK
   STA BKELECT
   LDA VDCDDR+0
   LDY VDCDDR+1
   STA SYSWORK+0
   STY SYSWORK+1
   ;PLP $$$
   RTS

VDCINCOLOR = *
   PHP
   SEI
   CMP #128
   BCC +
   PHA
   TXA
   JSR RGBI2VIC
   STA VIC+$21
   ASL
   ASL
   ASL
   ASL
   STA VDCACKOLOR
   PLA
+  AND #64
   BEQ VDCINCOLORXIT
   TYA
   JSR RGBI2VIC
   BIT VICSCTIVE
   BMI +
   STA VIC+$20
   JMP VDCINCOLORXIT
+  STA VICSOLOR

   VDCINCOLORXIT = *
   BIT VICSCTIVE
   BMI +
   LDA VIC+$20
   JMP ++
+  LDA VICSOLOR
+  JSR VIC2RGBI
   TAY
   LDA VIC+$21
   JSR VIC2RGBI
   TAX
   PLP
   RTS

VDCINPOS = *
   JSR VDCULT80
   VDCINPOSDD = *
   CLC
   LDA SYSWORK+0
   ADC VDCINTART+0
   STA SYSWORK+0
   LDA SYSWORK+1
   ADC VDCINTART+1
   STA SYSWORK+1
   RTS

VDCOS320 = *
   JSR VDCULT320
   JSR VDCINPOSDD
   VDCOSDD = *
   CLC
   LDA SYSWORK+0
   ADC #<VDCHARDDR
   STA SYSWORK+0
   LDA SYSWORK+1
   ADC #>VDCHARDDR
   STA SYSWORK+1
   RTS

VDCULT320 = * ;( .=ROW:0-50, .=COL ) : (SW+0)=(ROW*80+COL)*4
   JSR VDCULT80
   ASL SYSWORK+0
   ROL SYSWORK+1
   ASL SYSWORK+0
   ROL SYSWORK+1
   RTS

VDCULT80 = *  ;( .=ROW:0-50, .=COL ) : (SW+0)=ROW*80+COL, .:UNCH
   STA SYSWORK+0
   LDY #0
   STY SYSWORK+1
   ASL
   ASL
   ADC SYSWORK+0
   ASL
   ROL SYSWORK+1
   ASL
   ROL SYSWORK+1
   ASL
   ROL SYSWORK+1
   ASL
   ROL SYSWORK+1
   STX SYSWORK+0
   CLC
   ADC SYSWORK+0
   BCC +
   INC SYSWORK+1
+  STA SYSWORK+0
   RTS

VDCURSORLASH .BYTE $00  ;$00=INACTIVE, $FF=ACTIVE
VDCURSORTATE .BUF 1     ;$00=FLASHFF, $FF=FLASHN
VDCURSOROUNTDOWN .BUF 1
VDCURSORDDR  .BUF 2

VDCINCURSOR = *
   CMP #0
   BEQ VDCURSORFF
   ;XX IGNORE COLOR
   JSR VDCDDHAR
   LDA SYSWORK+0
   LDY SYSWORK+1
   STA VDCURSORDDR+0
   STY VDCURSORDDR+1
   LDA #0
   STA VDCURSORTATE
   LDA #1
   STA VDCURSOROUNTDOWN
   JSR VDCRQURSORNTER
   LDA #$FF
   STA VDCURSORLASH
   RTS

VDCURSORFF = *
   ;XX IGNORE GIVEN ADDR
   LDA #0
   STA VDCURSORLASH
   LDA VDCURSORTATE
   BEQ +
   LDA #1
   STA VDCURSOROUNTDOWN
   JSR VDCRQURSORNTER
+  RTS

VDCRQORK = $A0
VDCURSORASK .BUF 1

VDCRQURSOR = *
   BIT VDCURSORLASH
   BMI VDCRQURSORNTER
-  RTS
   VDCRQURSORNTER = *
   DEC VDCURSOROUNTDOWN
   BNE -
   LDA #20
   STA VDCURSOROUNTDOWN
   LDA VDCURSORDDR+0
   LDY VDCURSORDDR+1
   AND #%11111000
   STA VDCRQORK+0
   STY VDCRQORK+1
   LDX #$F0
   LDA VDCURSORDDR+0
   AND #%00000111
   BEQ +
   LDX #$0F
+  STX VDCURSORASK
   LDA #BKAM0
   STA BKELECT
   LDY #7
-  LDA (VDCRQORK),Y
   EOR VDCURSORASK
   STA (VDCRQORK),Y
   DEY
   BPL -
   LDA #BK
   STA BKELECT
   LDA VDCURSORTATE
   EOR #$FF
   STA VDCURSORTATE
   RTS

VDCCROLLOURCE = SYSWORK+0
VDCCROLLEST   = SYSWORK+2
VDCCROLLYTES  = SYSWORK+4
VDCCROLLOWS   .BUF 1
VDCCROLLXTRA  .BUF 1
VDCCROLLEUORK .BUF 4
VDCCROLLLAGS  .BUF 1
VDCCROLLILLHAR .BUF 1

VDCINSCROLL = *
   STA VDCCROLLLAGS
   STY VDCLSOLOR
   STX VDCCROLLXTRA
   LDA SYSWORK+4
   STA VDCCROLLILLHAR
   CPX #0
   BNE +
-  RTS
+  LDA VDCCROLLLAGS
   AND #$08
   BEQ -
   CPX VDCINOWS
   BCC +
   LDX VDCCROLLILLHAR
   LDA VDCCROLLLAGS
   LDY VDCLSOLOR
   JSR VDCINCLS
   RTS
+  BIT VDCCROLLLAGS
   BPL +
   ;** SCROLL CHARACTERS
   JSR VDCASTCROLLP
+  BIT VDCCROLLLAGS
   BVC +
   ;XX SCROLL COLORS
+  RTS

VDCASTCROLLP = *
   ;** SET LENGTH
   SEC
   LDA VDCINOWS
   SBC VDCCROLLXTRA
   LDX #0
   JSR VDCULT320
   LDA SYSWORK+0
   LDY SYSWORK+1
   STA VDCCROLLYTES+0
   STY VDCCROLLYTES+1
   ;** SET DEST
   LDA #0
   LDX #0
   JSR VDCOS320
   LDA SYSWORK+0
   LDY SYSWORK+1
   STA VDCCROLLEST+0
   STY VDCCROLLEST+1
   ;** SET SOURCE
   LDA VDCCROLLXTRA
   LDX #0
   JSR VDCOS320
   ;** SCROLL
   JSR VDCOPYORWARD
   ;** BLANK SCREEN BOTTOM
   SEC
   LDA VDCINOWS
   SBC VDCCROLLXTRA
   LDX #0
   JSR VDCOS320
   LDA VDCCROLLXTRA
   STA VDCILLOWS
   LDA #0
   STA VDCILLYTE
   JSR VDCOWILL
   RTS

VDCOPYORWARD = *  ;( VDCCROLLOURCE, VDCCROLLEST, VDCCROLLYTES )
   LDA VDCCROLLEUORK+3
   CMP #ACEEMULL
   BEQ +
   JMP VDCOPYEU
   ;** SET UP SOFT COPY
+  LDA #BKAM0
   STA BKELECT
   LDA VDCCROLLOURCE+0
   LDY VDCCROLLOURCE+1
   STA VDCSROM+1
   STY VDCSROM+2
   LDA VDCCROLLEST+0
   LDY VDCCROLLEST+1
   STA VDCSO+1
   STY VDCSO+2
   LDY VDCCROLLYTES+1
   LDX #0
   ;** COPY
VDCSROM  LDA $FFFF,X
VDCSO    STA $FFFF,X
   INX
   BNE VDCSROM
   INC VDCSROM+2
   INC VDCSO+2
   DEY
   BNE VDCSROM
   ;** COPY LAST PAGE
   LDX #5
-  LDA VDCSROM,X
   STA VDCOPYAST,X
   DEX
   BPL -
   LDX #0
   CPX VDCCROLLYTES+0
   BEQ +
   VDCOPYAST = *
   LDA $FFFF,X
   STA $FFFF,X
   INX
   CPX VDCCROLLYTES+0
   BNE VDCOPYAST
   ;** FINISH
+  LDA #BK
   STA BKELECT
   RTS

VDCOPYEUAVE .BUF 10

VDCOPYEU = *
   LDX #7
-  LDA ZP,X
   STA VDCOPYEUAVE+0,X
   DEX
   BPL -
   LDA #%01110101
   STA BKELECT
   LDA VDCCROLLOURCE+0
   LDY VDCCROLLOURCE+1
   STA ZP+0
   STY ZP+1
   LDX #3
-  LDA VDCCROLLEUORK,X
   STA MP,X
   DEX
   BPL -
   LDA VDCCROLLYTES+0
   LDY VDCCROLLYTES+1
   JSR STASH
   LDA VDCCROLLEST+0
   LDY VDCCROLLEST+1
   STA ZP+0
   STY ZP+1
   LDA VDCCROLLYTES+0
   LDY VDCCROLLYTES+1
   JSR FETCH
   LDA #BK
   STA BKELECT
   LDX #7
-  LDA VDCOPYEUAVE+0,X
   STA ZP,X
   DEX
   BPL -
   RTS

;*** INTERRUPT SCREEN-SAVER: WORK HANDLED BY  SCREEN DRIVER

VDCSOLOR  .BUF 1
VDCSODE   .BUF 1
VDCSCTIVE .BYTE $00

VDCCREENAVE = *
   RTS

VDCCREENNSAVE = *
   RTS

VDCMOLOR .BUF 1

ACERCREEN = *
   STY VDCMOLOR
   LDA CONFIGUF+$C0
   BMI +
   LDA #ACERRORAPHICSPACE
   STA ERRNO
   SEC
   RTS
+  TXA
   JSR RGBI2VIC
   STA VIC+$20
   JSR VDCNIT
   LDA #$E0
   LDX #$00
   LDY VDCMOLOR
   JSR VDCINCLSATTERN
   LDA #200
   LDY #0
   STA SYSWORK+0
   STY SYSWORK+1
   LDA #40
   LDX #1
   CLC
   RTS

ACERXIT = *
   LDX #40
   BIT TEXTODE
   BPL +
   LDX #80
+  LDA #25
   JSR CONSCREEN
   CLC
   RTS

ACERILL = *
   TAX
   LDA #$80
   JSR VDCINCLSATTERN
   CLC
   RTS

GRLOADOLS .BUF 1
GRLOADOWS .BUF 1
GRLOADOL  .BUF 1

ACEROAD = *
   STA GRLOADOL
   STX GRLOADOLS
   STY GRLOADOWS
   LDA SYSWORK+0
   PHA
   LSR
   LSR
   LSR
   LDX #0
   JSR VDCULT320
   PLA
   AND #$07
   CLC
   ADC SYSWORK+0
   STA SYSWORK+0
   BCC +
   INC SYSWORK+1
+  LDA GRLOADOL
   LDY #0
   STY SYSWORK+4
   LDX #3
-  ASL
   ROL SYSWORK+4
   DEX
   BNE -
   CLC
   ADC SYSWORK+0
   STA SYSWORK+0
   LDA SYSWORK+1
   ADC SYSWORK+4
   STA SYSWORK+1
   JSR VDCOSDD
   LDA GRLOADOLS
   BNE +
   CLC
   RTS
+  LDY #0
-  LDA (SYSWORK+2),Y
   STY SYSWORK+4
   LDY #0
   STA (SYSWORK+0),Y
   LDY SYSWORK+4
   CLC
   LDA SYSWORK+0
   ADC #8
   STA SYSWORK+0
   BCC +
   INC SYSWORK+1
+  INY
   CPY GRLOADOLS
   BCC -
   CLC
   RTS

;THE END + BLANK LINE

